using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using System.Text;

namespace _13_MDIChildArrange
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class Form1 : System.Windows.Forms.Form
	{
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

        ChildForm[] childForms = new ChildForm[3];

        public Form1()
        {
            InitializeComponent();

            for( int i = 0; i < 3; i++ )
            {
                childForms[i] = new ChildForm();
                childForms[i].MdiParent = this;
                childForms[i].Show();
            }
        }

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
            // 
            // Form1
            // 
            this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
            this.ClientSize = new System.Drawing.Size(696, 534);
            this.IsMdiContainer = true;
            this.Name = "Form1";
            this.StartPosition = System.Windows.Forms.FormStartPosition.CenterScreen;
            this.Text = "Form1";
            this.MdiChildActivate += new System.EventHandler(this.Form1_MdiChildActivate);
            this.VisibleChanged += new System.EventHandler(this.Form1_VisibleChanged);

        }
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new Form1());
		}

        private void Form1_MdiChildActivate(object sender, System.EventArgs e)
        {
            StringBuilder childTitle = new StringBuilder();
            foreach( Form child in this.MdiChildren )
            {
                childTitle.Append(child.Text);
                childTitle.Replace( "- Active", "" );

                if( this.ActiveMdiChild == child )
                {
                    child.ActiveControl.Text = "Active Child";
                    child.Text = childTitle.ToString() + "- Active";
                    
                }
                else
                {
                    child.Controls[0].Text = "Not Active Child";
                    child.Text = childTitle.ToString();
                }
                childTitle.Remove(0, childTitle.Length);
            }
        }

        private void Form1_VisibleChanged(object sender, System.EventArgs e)
        {
            this.Visible = true;
            
            this.LayoutMdi( MdiLayout.Cascade );
            MessageBox.Show( "Cascading MDI Child Windows" );

            this.LayoutMdi( MdiLayout.TileVertical );
            MessageBox.Show( "Vertically Tiled MDI Child Windows" );

            this.LayoutMdi( MdiLayout.TileHorizontal );
            MessageBox.Show( "Horizontally Tiled MDI Child Windows" );
        }
	}
}
