using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;

namespace _5_FormEvents
{
	public class EventForm : System.Windows.Forms.Form
	{
		private System.ComponentModel.Container components = null;

		public EventForm()
		{
			InitializeComponent();
		}

        protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		private void InitializeComponent()
		{
            // 
            // EventForm
            // 
            this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
            this.ClientSize = new System.Drawing.Size(292, 266);
            this.Name = "EventForm";
            this.Text = "EventForm";
            this.MouseDown += new System.Windows.Forms.MouseEventHandler(this.EventForm_MouseDown);
            this.Closing += new System.ComponentModel.CancelEventHandler(this.EventForm_Closing);
            this.Load += new System.EventHandler(this.EventForm_Load);
            this.MouseUp += new System.Windows.Forms.MouseEventHandler(this.EventForm_MouseUp);
            this.MouseHover += new System.EventHandler(this.EventForm_MouseHover);
            this.Move += new System.EventHandler(this.EventForm_Move);
            this.LocationChanged += new System.EventHandler(this.EventForm_LocationChanged);
            this.Activated += new System.EventHandler(this.EventForm_Activated);
            this.MouseEnter += new System.EventHandler(this.EventForm_MouseEnter);
            this.MouseLeave += new System.EventHandler(this.EventForm_MouseLeave);

        }
		#endregion

        private void EventForm_Load(object sender, System.EventArgs e)
        {
            Console.WriteLine( "Form Loaded: {0}", e.ToString() );
        }

        private void EventForm_LocationChanged(object sender, System.EventArgs e)
        {
            Console.WriteLine( "Location Changed" );
        }

        private void EventForm_MouseDown(object sender, System.Windows.Forms.MouseEventArgs e)
        {
            Console.WriteLine( "Mouse Down - Button: {0} X: {1} Y: {2}", e.Button.ToString(), e.X, e.Y );
        }

        private void EventForm_MouseEnter(object sender, System.EventArgs e)
        {
            Console.WriteLine( "Mouse Enter" );
        }

        private void EventForm_MouseHover(object sender, System.EventArgs e)
        {
            Console.WriteLine( "Mouse Hover" );
        }

        private void EventForm_MouseLeave(object sender, System.EventArgs e)
        {
            Console.WriteLine( "Mouse Leave" );
        }

        private void EventForm_MouseUp(object sender, System.Windows.Forms.MouseEventArgs e)
        {
            Console.WriteLine( "Mouse Down - Button: {0} X: {1} Y: {2}", e.Button.ToString(), e.X, e.Y );
        }

        private void EventForm_Move(object sender, System.EventArgs e)
        {
            Console.WriteLine( "Form Moved" );
        }

        private void EventForm_Activated(object sender, System.EventArgs e)
        {
        
        }

        private void EventForm_Closing(object sender, System.ComponentModel.CancelEventArgs e)
        {
            if( MessageBox.Show( "Are you sure you want to quit?", "Quit?", MessageBoxButtons.YesNo ) == DialogResult.No )
            {
                e.Cancel = true;
            }
            else
            {
                e.Cancel = false;
            }
        }
	}
}
