using System;

namespace _14_Looping
{
    /// <summary>
    /// Summary description for Class1.
    /// </summary>
    class Game
    {
        /// <summary>
        /// The main entry point for the application.
        /// </summary>
        [STAThread]
        static void Main(string[] args)
        {
            ComputeFactorial();
            WaitForNewMinute();
            NumberGuessGame();

        }

        static void ComputeFactorial()
        {
            ulong loopCount = 0;
            ulong factorial = 1;
            Console.Write( "Enter an integer between 1 and 50: " );
            loopCount = UInt64.Parse( Console.ReadLine() );
            for( ulong i = loopCount; i > 0; i-- )
            {
                factorial *= i;
            }
            Console.WriteLine( "{0}! = {1}", loopCount, factorial );
        }

        static void WaitForNewMinute()
        {
            int sec = -1;

            Console.Write( "The game will start in " );
            while( DateTime.Now.Second != 0 )
            {
                if( sec != DateTime.Now.Second )
                {
                    sec = DateTime.Now.Second;
                    Console.Write( "...{0}", 60-DateTime.Now.Second );
                }
            }
            Console.WriteLine();
        }
        static void NumberGuessGame()
        {
            int guess, number, guesses = 0;
            number = new Random((int)DateTime.Now.Ticks).Next( 0, 10 );

            do
            {
                ++guesses;

                Console.Write( "Enter a number between 1 and 10: " );
                guess = Int32.Parse( Console.ReadLine() );

                if( guess < number )
                    Console.WriteLine( "Too low. Pick a higher number" );
                else if ( guess > number )
                    Console.WriteLine( "Too high. Pick a lower number" );
                    
            } while (guess != number );

            Console.WriteLine( "You are correct and it only took you {0} tries!", guesses );
        }
    }
}
