using System;

namespace _11_Interfaces
{
    public abstract class MediaDevice
    {
        bool on = false;
        virtual public void TurnOn()
        {
            on = true;
        }

        virtual public void TurnOff()
        {
            on = false;
        }
        public void NonOverride()
        {
            Console.WriteLine( "This method is not virtual" );
        }
        public abstract int VolumeLevel
        {
            get;
            set;
        }  
    }
    public interface IMediaDevice
    {
        void TurnOn();
        void TurnOff();
        int VolumeLevel
        {
            get;
            set;
        }
    }

    public class Radio : MediaDevice
    {
        private int volume = 0;
        private const int maxVolume = 100;

        public override int VolumeLevel
        {
            get
            {
                return volume;
            }
            set
            {
                if( value > 100 )
                    return;
                volume = value;
            }
        }

        public override void TurnOff()
        {
            base.TurnOff ();
        }

    }

    
	class Class1
	{
		[STAThread]
		static void Main(string[] args)
		{
            MediaDevice md = (MediaDevice) new Radio();
            md.VolumeLevel = 2;
            md.TurnOff();

            Console.WriteLine( "{0}", md.ToString() );
            md.NonOverride();
		}
	}
}
