using System;
using System.Text.RegularExpressions;
using System.Reflection;

namespace _12_RegExpReplace
{
	class Class1
	{
		[STAThread]
		static void Main(string[] args)
		{
            Regex cardExp = new Regex( @"(\d{4})-(\d{4})-(\d{4})-(\d{4})" );
            
            string safeOutputExp = "$1-xxxx-xxxx-$4";
            string cardNum;

            Console.Write( "Please enter your credit card number: " );
            cardNum = Console.ReadLine();
        
            while( cardExp.IsMatch( cardNum ) == false )
            {
                Console.WriteLine( "Invalid card number. Try again." );
                Console.Write( "Please enter your credit card number: " );

                cardNum = Console.ReadLine();
            }

            Console.WriteLine( "Secure Output Result = {0}", cardExp.Replace( cardNum, safeOutputExp ));

            TestManualGrouping();
            CompileRegex( cardExp.ToString(), @"regexlib" );
		}
        
        static void CompileRegex( string exp, string assemblyName )
        {
            RegexCompilationInfo compInfo = new RegexCompilationInfo( exp, 0, "CreditCardExp", "", true );
            AssemblyName assembly = new AssemblyName();
            assembly.Name = assemblyName;

            RegexCompilationInfo[] rciArray = { compInfo };

            Regex.CompileToAssembly( rciArray, assembly );
        }

        static void TestManualGrouping()
        {
            Regex cardExp = new Regex( @"\d{4}" );
            string cardNum;
            string safeOutputExp = "";

            Console.Write( "Please enter your credit card number: " );
            cardNum = Console.ReadLine();

            if( cardExp.Matches( cardNum ).Count < 4 )
            {
                Console.WriteLine( "Invalid card number" );
                return;
            }

            foreach( Match field in cardExp.Matches( cardNum ))
            {
                if( field.Success == false )
                {
                    Console.WriteLine( "Invalid card number" );
                    return;
                }

                if( field.Index == 5 || field.Index == 10 )
                {
                    safeOutputExp += "-xxxx-";
                }
                else
                {
                    safeOutputExp += field.Value;
                }
            }

            Console.WriteLine( "Secure Output Result = {0}", safeOutputExp );
        }
	}
}
