using System;
using System.Collections;

namespace _11_Sorting
{
	class Class1
	{
		[STAThread]
		static void Main(string[] args)
		{
            string input;
            ArrayList alPeople = new ArrayList();
            Console.Write( "Enter first and last name or 'q' to quit: " );
            input = Console.ReadLine();

            // get list of names from user
            while( input.Length != 1 || Char.ToUpper(input[0]) != 'Q' )
            {
                string[] name = input.Split( new char[]{' '}, 2 );
                alPeople.Add( new Person( name[0], name[1] ));
                
                Console.Write( "Enter first and last name or 'q' to quit: " );
                input = Console.ReadLine();
            }

            // output unsorted names
            Console.WriteLine( "\nArray before sort" );
            foreach( Person p in alPeople )
            {
                Console.WriteLine( "   {0} {1}", p.firstName, p.lastName );
            }

            // sort arraylist using custom IComparer
            alPeople.Sort( new Person() );

            // output sorted array
            Console.WriteLine( "\nArray after sort" );
            foreach( Person p in alPeople )
            {
                Console.WriteLine( "   {0} {1}", p.firstName, p.lastName );
            }
		}
	}

    struct Person : IComparer
    {
        public string firstName;
        public string lastName;

        public Person( string first, string last )
        {
            firstName = first;
            lastName = last;
        }

        public int Compare( object a, object b )
        {
            int lNameCmp;
            int fNameCmp;

            Person pa = (Person) a;
            Person pb = (Person) b;

            lNameCmp = String.Compare( pa.lastName, pb.lastName );
            if( lNameCmp != 0 ) return lNameCmp;

            fNameCmp = String.Compare( pa.firstName, pb.firstName );

            return fNameCmp;
        }
    }
}
