using System;
using System.Collections;

namespace _8_BitArrays
{
    enum Ingredients
    {
        ice, sugar, cream, chocolate, milk, syrup, cinnamon, decaf
    }

    class Coffee
    {
        private BitArray ingredientFlags;

        public Coffee()
        {
            ingredientFlags = new BitArray(8);
        }

        public void AddIngredient(Ingredients Ingredient)
        {
            ingredientFlags[(int) Ingredient] = true;
        }

        public void ListIngredients()
        {
            Console.WriteLine( "Coffee Ingredients\n------------------");
            for( int i = 0; i < ingredientFlags.Count; i++ )
            {
                if( ingredientFlags[i] )
                    Console.WriteLine( "-" + Enum.GetName(typeof(Ingredients), i) );
            }
        }

        public void Drink()
        {            
            ingredientFlags.Xor( ingredientFlags );
            Console.WriteLine( "\nDrank Coffee" );
            ListIngredients();
        }
    }

	class Class1
	{
		[STAThread]
		static void Main(string[] args)
		{
            Coffee java = new Coffee();

            java.AddIngredient( Ingredients.sugar );
            java.AddIngredient( Ingredients.cream );
            java.AddIngredient( Ingredients.decaf );

            java.ListIngredients();

            java.Drink();
		}
	}
}
