using System;

namespace _1_Delegates
{
    class Class1
    {
        [STAThread]
        static void Main(string[] args)
        {
            // instantiate delegates
            StringPrinterDelegate.PrintString internalPrint = new StringPrinterDelegate.PrintString( StringPrinterDelegate.InternalImp );
            StringPrinterDelegate.PrintString firstCharPrint = new StringPrinterDelegate.PrintString( FirstCharPrint );
        
            // get string from user
            Console.Write( "Enter a string: " );
            string input = Console.ReadLine();

            // call delegates directly
            internalPrint( input );
            firstCharPrint( input );

            // pass delegates as parameter
            StringPrinterDelegate.PrintWithDelegate( internalPrint, input );
            StringPrinterDelegate.PrintWithDelegate( firstCharPrint, input );
        }

        // external delegate implementation
        static void FirstCharPrint( string s )
        {
            string[] splitStrings = s.Split( new char[]{' '} );
            foreach( string splitString in splitStrings )
            {
                Console.Write( "{0}", splitString[0] );
                for( int i = 0; i < splitString.Length; i++ )
                    Console.Write( " " );
            }
            Console.WriteLine();
        }
    }

    class StringPrinterDelegate
    {
        public delegate void PrintString( string s );
      
        // delegate passed as parameter
        public static void PrintWithDelegate( PrintString psDelegate, string s )
        {
            psDelegate( s );
        }

        // internal delegate implementation
        public static void InternalImp( string s )
        {
            Console.WriteLine( s );
        }
    }
}
