using System;

namespace _2_MulticastDelegate
{
    class Class1
    {
        [STAThread]
        static void Main(string[] args)
        {
            // instantiate delegate
            StringPrinterDelegate.PrintString[] printDelegates = new StringPrinterDelegate.PrintString[3];
            StringPrinterDelegate.PrintString stringPrinters;

            printDelegates[0] = new StringPrinterDelegate.PrintString( NormalPrint );
            printDelegates[1] = new StringPrinterDelegate.PrintString( FirstCharPrint );
            printDelegates[2] = new StringPrinterDelegate.PrintString( LastCharPrint );

            stringPrinters = (StringPrinterDelegate.PrintString) Delegate.Combine( printDelegates );
            
            // addition assignment to bind implementation to delegate
            stringPrinters += printDelegates[0];
            
            // get string from user
            Console.Write( "Enter a string: " );
            string input = Console.ReadLine();

            StringPrinterDelegate.PrintWithDelegate( stringPrinters, input );

            // remove last implementation using subtraction assignment
            stringPrinters -= printDelegates[2];
            Console.WriteLine( "\nAfter remove:" );
            StringPrinterDelegate.PrintWithDelegate( stringPrinters, input );
            
            // remove directly
            Delegate[] delegateList = stringPrinters.GetInvocationList();
            stringPrinters -= (StringPrinterDelegate.PrintString) delegateList[delegateList.Length-1];
            Console.WriteLine( "\nAfter 2nd remove:" );
            StringPrinterDelegate.PrintWithDelegate( stringPrinters, input );
        }

        static void NormalPrint( string s )
        {
            Console.WriteLine( s );
        }

        static void FirstCharPrint( string s )
        {
            string[] splitStrings = s.Split( new char[]{' '} );
            foreach( string splitString in splitStrings )
            {
                Console.Write( "{0}", splitString[0] );
                for( int i = 0; i < splitString.Length; i++ )
                    Console.Write( " " );
            }
            Console.WriteLine();
        }
        static void LastCharPrint( string s )
        {
            string[] splitStrings = s.Split( new char[]{' '} );
            foreach( string splitString in splitStrings )
            {
                for( int i = 0; i < splitString.Length-1; i++ )
                    Console.Write( " " );
                Console.Write( "{0} ", splitString[splitString.Length-1] );
            }
            Console.WriteLine();
        }
    }

    class StringPrinterDelegate
    {
        public delegate void PrintString( string s );
      
        // delegate passed as parameter
        public static void PrintWithDelegate( PrintString psDelegate, string s )
        {
            psDelegate( s );
        }
    }
}
