using System;
using System.Threading;
using System.Runtime.Remoting.Messaging;
using System.Net;
using System.IO;
using System.Text;

namespace _5_AsynchronousDelegate
{
     public delegate bool TearWebPage( string url );

    class Class1
	{
		[STAThread]
		static void Main(string[] args)
		{
            // create delegate attached to DoAsynchSleep method
            TearWebPage tear = new TearWebPage( new WebTear().TearPage );

            // create result class and create callback object
            TearCallback result = new TearCallback();
            AsyncCallback ascb = new AsyncCallback( result.PrintTearResult );

            IAsyncResult ar = tear.BeginInvoke( "http://www.samspublishing.com", ascb, null );

            // long operation here
            Thread.Sleep(10000);
		}
	}

    class TearCallback
    {
        public void PrintTearResult( IAsyncResult ar)
        {
            TearWebPage tear = (TearWebPage)((AsyncResult)ar).AsyncDelegate;

            Console.WriteLine( "TearPage returned {0}", tear.EndInvoke( ar ) );
        }
    }

    class WebTear
    {
        public bool TearPage( string url )
        {
            StringBuilder pageText = new StringBuilder("");

            Uri HttpSite = new Uri(url);
            HttpWebRequest wreq = (HttpWebRequest) WebRequest.Create(HttpSite);
            wreq.AllowAutoRedirect = true;

            Stream webStream = wreq.GetResponse().GetResponseStream();

            byte[] webResponse = new byte[1024];
            int bytesRead = 0;

            do
            {
                bytesRead = webStream.Read( webResponse, 0, 1024 );
                if( bytesRead > 0 )
                    pageText.Append( Encoding.ASCII.GetString( webResponse, 0, bytesRead ));

            } while( bytesRead > 0 );
               
            Console.WriteLine( pageText.ToString() );

            return true;
        }
    }
}
