using System;
using System.Collections;

namespace _4_EventArgs
{
    class Class1
    {
        [STAThread]
        static void Main(string[] args)
        {
            ConsoleMenu menu = new ConsoleMenu();
            menu.AddMenuItem( "Enter DTL Database Info" );
            menu.AddMenuItem( "List Common Ground Data" );
            menu.AddMenuItem( "Manage cqxweb.com" );
            menu.AddMenuItem( "Quit" );
            
            menu.OnMenuEvent += new ConsoleMenu.MenuEventHandler( MenuItemHandler );

            menu.DisplayMenu();
        }

        static void MenuItemHandler( object sender, MenuItemEventArgs e )
        {
            switch( e.id )
            {
                case( 1 ):
                case( 2 ):
                case( 3 ):
                {
                    Console.WriteLine( "You selected the item {0}\n", e.displayString );                    
                    break;
                }
                case( 4 ):
                {
                    Console.WriteLine( "Goodbye!" );
                    ((ConsoleMenu)sender).QuitMenu();
                    break;
                }
            }
        }
    }

    public class MenuItemEventArgs : EventArgs
    {
        public int id;
        public string displayString;

        public MenuItemEventArgs( int id, string displayString )
        {
            this.id = id;
            this.displayString = displayString;
        }
    }

    class ConsoleMenu
    {
        ArrayList menuItems = new ArrayList();
        bool quitMenu = false;

        public delegate void MenuEventHandler( object sender, MenuItemEventArgs mie );

        public event MenuEventHandler OnMenuEvent;

        public void AddMenuItem( string text )
        {
            menuItems.Add( text );
        }

        public void QuitMenu()
        {
            quitMenu = true;
        }

        public void DisplayMenu()
        {
            string input;
            do
            {
                int idx = 1;
                int choice = 0;

                foreach( string menuChoice in menuItems )
                    Console.WriteLine( "{0}: {1}", idx++, menuChoice );
                
                Console.Write( "Enter choice: " );

                input = Console.ReadLine();
                choice = Int32.Parse( input[0].ToString() );

                if( choice > 0 && choice <= menuItems.Count )
                {
                    OnMenuEvent( this, new MenuItemEventArgs(Int32.Parse(input[0].ToString()), menuItems[Int32.Parse(input[0].ToString())-1].ToString()));
                }
                else
                {
                    Console.WriteLine( "Invalid choice!\n" );
                }

            } while ( quitMenu == false );

            quitMenu = false;
        }
    }
}
