using System;

namespace _3_ExceptionInfo
{
    class Class1
    {
        [STAThread]
        static void Main(string[] args)
        {
            int input = DisplayMenu();

            while( input != 5 )
            {
                if( input == 1 || input == 2 )
                {
                    ThrowException( input );
                }
                else
                {
                    try
                    {
                        ThrowException( input );
                    }
                    catch( ApplicationException e )
                    {
                        Console.WriteLine( "An application exception occured:" );
                        DisplayExceptionInformation( e );
                    }
                    catch( SystemException e )
                    {
                        Console.WriteLine( "A system exception occured:" );
                        DisplayExceptionInformation( e );
                    }
                    catch( Exception e )
                    {
                        Console.WriteLine( "An unknown error occured:" );
                        DisplayExceptionInformation( e );
                    }
                }
                input = DisplayMenu();
            }
        }

        static void DisplayExceptionInformation( Exception e )
        {
            Console.WriteLine( "Application: {0}", e.Source );
            Console.WriteLine( "Method: {0}", e.TargetSite );
            Console.WriteLine( "Message: {0}", e.Message );
            Console.WriteLine( "Call Stack: {0}", e.StackTrace );
            if( e.HelpLink != null ) 
                Console.WriteLine( "Help Link: {0}", e.HelpLink );
        }

        static void ThrowException( int input )
        {
            switch( input )
            {
                case 1:
                case 3:
                {
                    throw new SystemException();
                }
                case 2:
                case 4:
                {
                    throw new ApplicationException();
                }
                default:
                {
                    throw new ArgumentException();
                }
            }
        }

        static int DisplayMenu()
        {
            int input = 0;

            Console.WriteLine( "1) Throw a system exception" );
            Console.WriteLine( "2) Throw an application exception" );
            Console.WriteLine( "3) Throw and catch system exception" );
            Console.WriteLine( "4) Throw and catch application exception" );
            Console.WriteLine( "5) Quit" );

            Console.Write( "Enter command: " );

            try
            {
                input = Int32.Parse( Console.ReadLine() );
            }
            catch
            {
                Console.WriteLine( "Invalid Input. Try again.\n" );
                return DisplayMenu();
            }
            return input;
        }
    }
}
