using System;

namespace _5_InnerExceptions
{
    class Class1
    {
        [STAThread]
        static void Main(string[] args)
        {
            TrafficMonitor tm = new TrafficMonitor();
            
            // loop until user enters a valid value
            for(;;)
            {
                try
                {
                    Console.Write( "Enter traffic capacity limit: " );
                    tm.CapacityLimit = Int32.Parse( Console.ReadLine() );

                    // at this point a valid value has been entered
                    break;
                }
                catch( Exception )
                {
                    Console.WriteLine( "You must enter a valid value" );
                }
            }

            // loop until user enters a valid value
            for(;;)
            {
                try
                {
                    Console.Write( "Enter current traffic capacity: " );
                    tm.CurrentCapacity = Int32.Parse( Console.ReadLine() );

                    // valid value entered, break out of loop
                    break;
                }
                catch( Exception )
                {
                    Console.WriteLine( "You must enter a valid value" );
                }
            }

            try
            {
                Console.WriteLine( tm.ToString() );
            }
            catch( Exception e )
            {
                for( Exception cur = e; cur.InnerException != null; cur = cur.InnerException )
                    Console.WriteLine( "Exception: {0}\nInner Exception: {1}", cur.Message, cur.InnerException.Message );
            }
        }
	}

    class TrafficMonitorException : ApplicationException
    {
        public TrafficMonitorException() : this(null){}
        public TrafficMonitorException( Exception e ) : base("A capacity value is set incorrectly", e ){}
    }

    class TrafficMonitor
    {
        private int limit = 0;
        private int current = 8;

        public int CapacityLimit
        {
            get
            {
                return limit;
            }
            set
            {
                limit = value;
            }
        }

        public int CurrentCapacity
        {
            get
            {
                return current;
            }
            set
            {
                current = value;
            }
        }

        public override string ToString()
        {
            try
            {
                return ((decimal)current/(decimal)limit).ToString("p",null);
            }
            catch( Exception e )
            {
                throw new TrafficMonitorException( e );
            }
        }
    }
}
