using System;

namespace _6_CheckedUnchecked
{
	class Class1
	{
		[STAThread]
		static void Main(string[] args)
		{
            Counter counter1 = new Counter( 1, false );
            Counter counter2 = new Counter( 1, true );

            // overflow detection disabled
            for( int i = 1; i < 15; i++ )
            {
                counter1 *= i;
                Console.WriteLine( counter1.Value );
            }

            try
            {
                // overflow detection enabled
                for( int i = 1; i < 15; i++ )
                {
                    counter2 *= i;
                    Console.WriteLine( counter2.Value );
                }
            }
            catch( Exception e )
            {
                Console.WriteLine( "Exception caught: {0}", e.Message );
            }
		}
	}

    class Counter
    {
        public int Value = 0;
        public bool EnableCheck = false;

        public Counter( int val, bool enableCheck )
        {
            this.Value = val;
            this.EnableCheck = enableCheck;
        }

        public static Counter operator * ( Counter op1, int op2 )
        {
            int newVal;

            if( op1.EnableCheck )
                newVal = checked( op1.Value * op2 );
            else
                newVal = unchecked( op1.Value * op2 );

            return new Counter( newVal, op1.EnableCheck );
        }
    }
}
