using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using System.Drawing.Text;

namespace _12_Fonts
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class Form1 : System.Windows.Forms.Form
	{
        private System.Windows.Forms.Label label1;
        private System.Windows.Forms.GroupBox groupBox1;
        private System.Windows.Forms.Panel panel1;
        private System.Windows.Forms.Label label2;
        private System.Windows.Forms.MainMenu mainMenu1;
        private System.Windows.Forms.MenuItem menuItem1;
        private System.Windows.Forms.MenuItem menuItem5;
        private System.Windows.Forms.ComboBox cbFonts;
        private System.Windows.Forms.NumericUpDown udSize;
        private System.Windows.Forms.MenuItem menuAA;
        private System.Windows.Forms.MenuItem menuAAGrid;
        private System.Windows.Forms.MenuItem menuClearType;
        private System.Windows.Forms.MenuItem menuSingleBit;
        private System.Windows.Forms.MenuItem menuSingleBitGrid;
        private System.Windows.Forms.MenuItem menuDefault;
        private System.Windows.Forms.MenuItem menuBold;
        private System.Windows.Forms.MenuItem menuItalic;
        private System.Windows.Forms.MenuItem menuUnderline;

        private bool bold = false;
        private bool italic = false;
        private bool underline = false;
        private TextRenderingHint textHint = TextRenderingHint.SystemDefault;

		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

        public Form1()
        {
            //
            // Required for Windows Form Designer support
            //
            InitializeComponent();

            // enumerate system fonts and add to combobox
            InstalledFontCollection installedFonts = new InstalledFontCollection();
            
            foreach(FontFamily family in installedFonts.Families)
            {
                if( family.IsStyleAvailable( FontStyle.Regular ) == true )
                    cbFonts.Items.Add( family.GetName(0) );
            }

            cbFonts.SelectedIndex = 0;
        }

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
            this.cbFonts = new System.Windows.Forms.ComboBox();
            this.label1 = new System.Windows.Forms.Label();
            this.groupBox1 = new System.Windows.Forms.GroupBox();
            this.label2 = new System.Windows.Forms.Label();
            this.udSize = new System.Windows.Forms.NumericUpDown();
            this.panel1 = new System.Windows.Forms.Panel();
            this.mainMenu1 = new System.Windows.Forms.MainMenu();
            this.menuItem1 = new System.Windows.Forms.MenuItem();
            this.menuItem5 = new System.Windows.Forms.MenuItem();
            this.menuDefault = new System.Windows.Forms.MenuItem();
            this.menuAA = new System.Windows.Forms.MenuItem();
            this.menuAAGrid = new System.Windows.Forms.MenuItem();
            this.menuClearType = new System.Windows.Forms.MenuItem();
            this.menuSingleBit = new System.Windows.Forms.MenuItem();
            this.menuSingleBitGrid = new System.Windows.Forms.MenuItem();
            this.menuBold = new System.Windows.Forms.MenuItem();
            this.menuItalic = new System.Windows.Forms.MenuItem();
            this.menuUnderline = new System.Windows.Forms.MenuItem();
            this.groupBox1.SuspendLayout();
            ((System.ComponentModel.ISupportInitialize)(this.udSize)).BeginInit();
            this.SuspendLayout();
            // 
            // cbFonts
            // 
            this.cbFonts.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
            this.cbFonts.Location = new System.Drawing.Point(124, 32);
            this.cbFonts.Name = "cbFonts";
            this.cbFonts.Size = new System.Drawing.Size(264, 21);
            this.cbFonts.TabIndex = 0;
            this.cbFonts.SelectedIndexChanged += new System.EventHandler(this.cbFonts_SelectedIndexChanged);
            // 
            // label1
            // 
            this.label1.Location = new System.Drawing.Point(124, 16);
            this.label1.Name = "label1";
            this.label1.Size = new System.Drawing.Size(100, 16);
            this.label1.TabIndex = 1;
            this.label1.Text = "Available Fonts";
            // 
            // groupBox1
            // 
            this.groupBox1.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
                | System.Windows.Forms.AnchorStyles.Right)));
            this.groupBox1.Controls.Add(this.label2);
            this.groupBox1.Controls.Add(this.udSize);
            this.groupBox1.Controls.Add(this.label1);
            this.groupBox1.Controls.Add(this.cbFonts);
            this.groupBox1.Location = new System.Drawing.Point(8, 8);
            this.groupBox1.Name = "groupBox1";
            this.groupBox1.Size = new System.Drawing.Size(568, 72);
            this.groupBox1.TabIndex = 5;
            this.groupBox1.TabStop = false;
            // 
            // label2
            // 
            this.label2.Location = new System.Drawing.Point(396, 16);
            this.label2.Name = "label2";
            this.label2.Size = new System.Drawing.Size(32, 16);
            this.label2.TabIndex = 3;
            this.label2.Text = "Size";
            // 
            // udSize
            // 
            this.udSize.Location = new System.Drawing.Point(396, 32);
            this.udSize.Maximum = new System.Decimal(new int[] {
                                                                   1000,
                                                                   0,
                                                                   0,
                                                                   0});
            this.udSize.Minimum = new System.Decimal(new int[] {
                                                                   1,
                                                                   0,
                                                                   0,
                                                                   0});
            this.udSize.Name = "udSize";
            this.udSize.Size = new System.Drawing.Size(48, 20);
            this.udSize.TabIndex = 2;
            this.udSize.Value = new System.Decimal(new int[] {
                                                                 12,
                                                                 0,
                                                                 0,
                                                                 0});
            this.udSize.ValueChanged += new System.EventHandler(this.udSize_ValueChanged);
            // 
            // panel1
            // 
            this.panel1.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
                | System.Windows.Forms.AnchorStyles.Left) 
                | System.Windows.Forms.AnchorStyles.Right)));
            this.panel1.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
            this.panel1.Location = new System.Drawing.Point(8, 88);
            this.panel1.Name = "panel1";
            this.panel1.Size = new System.Drawing.Size(568, 360);
            this.panel1.TabIndex = 6;
            this.panel1.Paint += new System.Windows.Forms.PaintEventHandler(this.panel1_Paint);
            // 
            // mainMenu1
            // 
            this.mainMenu1.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
                                                                                      this.menuItem1});
            // 
            // menuItem1
            // 
            this.menuItem1.Index = 0;
            this.menuItem1.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
                                                                                      this.menuItem5,
                                                                                      this.menuBold,
                                                                                      this.menuItalic,
                                                                                      this.menuUnderline});
            this.menuItem1.Text = "Options";
            // 
            // menuItem5
            // 
            this.menuItem5.Index = 0;
            this.menuItem5.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
                                                                                      this.menuDefault,
                                                                                      this.menuAA,
                                                                                      this.menuAAGrid,
                                                                                      this.menuClearType,
                                                                                      this.menuSingleBit,
                                                                                      this.menuSingleBitGrid});
            this.menuItem5.Text = "Anitalias Mode";
            // 
            // menuDefault
            // 
            this.menuDefault.Checked = true;
            this.menuDefault.Index = 0;
            this.menuDefault.Text = "SystemDefault";
            this.menuDefault.Click += new System.EventHandler(this.menuDefault_Click);
            // 
            // menuAA
            // 
            this.menuAA.Index = 1;
            this.menuAA.Text = "AntiAlias";
            this.menuAA.Click += new System.EventHandler(this.menuAA_Click);
            // 
            // menuAAGrid
            // 
            this.menuAAGrid.Index = 2;
            this.menuAAGrid.Text = "AntiAliasGridFit";
            this.menuAAGrid.Click += new System.EventHandler(this.menuAAGrid_Click);
            // 
            // menuClearType
            // 
            this.menuClearType.Index = 3;
            this.menuClearType.Text = "ClearTypeGridFit";
            this.menuClearType.Click += new System.EventHandler(this.menuClearType_Click);
            // 
            // menuSingleBit
            // 
            this.menuSingleBit.Index = 4;
            this.menuSingleBit.Text = "SingleBitPerPixel";
            this.menuSingleBit.Click += new System.EventHandler(this.menuSingleBit_Click);
            // 
            // menuSingleBitGrid
            // 
            this.menuSingleBitGrid.Index = 5;
            this.menuSingleBitGrid.Text = "SingleBitPerPixelGridFit";
            this.menuSingleBitGrid.Click += new System.EventHandler(this.menuSingleBitGrid_Click);
            // 
            // menuBold
            // 
            this.menuBold.Index = 1;
            this.menuBold.Text = "Bold";
            this.menuBold.Click += new System.EventHandler(this.menuBold_Click);
            // 
            // menuItalic
            // 
            this.menuItalic.Index = 2;
            this.menuItalic.Text = "Italic";
            this.menuItalic.Click += new System.EventHandler(this.menuItalic_Click);
            // 
            // menuUnderline
            // 
            this.menuUnderline.Index = 3;
            this.menuUnderline.Text = "Underline";
            this.menuUnderline.Click += new System.EventHandler(this.menuUnderline_Click);
            // 
            // Form1
            // 
            this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
            this.ClientSize = new System.Drawing.Size(584, 457);
            this.Controls.Add(this.panel1);
            this.Controls.Add(this.groupBox1);
            this.Menu = this.mainMenu1;
            this.Name = "Form1";
            this.Text = "Font Test";
            this.groupBox1.ResumeLayout(false);
            ((System.ComponentModel.ISupportInitialize)(this.udSize)).EndInit();
            this.ResumeLayout(false);

        }
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new Form1());
		}

        private void panel1_Paint(object sender, System.Windows.Forms.PaintEventArgs e)
        {
            FontStyle fs = 0;
            if( menuBold.Enabled == true && bold == true )
                fs |= FontStyle.Bold;
            if( menuItalic.Enabled == true && italic == true )
                fs |= FontStyle.Italic;
            if( menuUnderline.Enabled == true && underline == true )
                fs |= FontStyle.Underline;

            Font f = new Font( cbFonts.SelectedItem.ToString(), (float) udSize.Value, fs );

            e.Graphics.TextRenderingHint = textHint;
            e.Graphics.DrawString( "C# Font Test", f, new SolidBrush( Color.Black ), panel1.DisplayRectangle);
        }

        private void cbFonts_SelectedIndexChanged(object sender, System.EventArgs e)
        {
            // get font family name
            FontFamily ff = new FontFamily(cbFonts.SelectedItem.ToString());
            if( ff.IsStyleAvailable( FontStyle.Bold ) == true )
                menuBold.Enabled = true;
            else
                menuBold.Enabled = false;

            if( ff.IsStyleAvailable( FontStyle.Italic ) == true )
                menuItalic.Enabled = true;
            else
                menuItalic.Enabled = false;

            if( ff.IsStyleAvailable( FontStyle.Underline ) == true )
                menuUnderline.Enabled = true;
            else
                menuUnderline.Enabled = false;

            panel1.Invalidate();
        }

        private void menuBold_Click(object sender, System.EventArgs e)
        {
            if( menuBold.Checked == true )
            {
                menuBold.Checked = false;
                bold = false;
            }
            else
            {
                menuBold.Checked = true;
                bold = true;
            }

            panel1.Invalidate();
        }

        private void menuItalic_Click(object sender, System.EventArgs e)
        {
            if( menuItalic.Checked == true )
            {
                menuItalic.Checked = false;
                italic = false;
            }
            else
            {
                menuItalic.Checked = true;
                italic = true;
            }

            panel1.Invalidate();        
        }

        private void menuUnderline_Click(object sender, System.EventArgs e)
        {
            if( menuUnderline.Checked == true )
            {
                menuUnderline.Checked = false;
                underline = false;
            }
            else
            {
                menuUnderline.Checked = true;
                underline = true;
            }

            panel1.Invalidate();
        }

        private void udSize_ValueChanged(object sender, System.EventArgs e)
        {
            panel1.Invalidate();
        }

        private void menuDefault_Click(object sender, System.EventArgs e)
        {
            textHint = TextRenderingHint.SystemDefault;
            EnableAntialiasMenuOption( menuDefault );
        }

        private void menuAA_Click(object sender, System.EventArgs e)
        {
            textHint = TextRenderingHint.AntiAlias;
            EnableAntialiasMenuOption( menuAA );
        }

        private void menuAAGrid_Click(object sender, System.EventArgs e)
        {
            textHint = TextRenderingHint.AntiAliasGridFit;
            EnableAntialiasMenuOption( menuAAGrid );
        }

        private void menuClearType_Click(object sender, System.EventArgs e)
        {
            textHint = TextRenderingHint.ClearTypeGridFit;
            EnableAntialiasMenuOption( menuClearType );
        }

        private void menuSingleBit_Click(object sender, System.EventArgs e)
        {
            textHint = TextRenderingHint.SingleBitPerPixel;
            EnableAntialiasMenuOption( menuSingleBit );
        }

        private void menuSingleBitGrid_Click(object sender, System.EventArgs e)
        {
            textHint = TextRenderingHint.SingleBitPerPixelGridFit;
            EnableAntialiasMenuOption( menuSingleBitGrid );
        }

        private void EnableAntialiasMenuOption( MenuItem item )
        {
            foreach( MenuItem curItem in item.Parent.MenuItems )
            {         
                if( curItem == item )
                    curItem.Checked = true;
                else
                    curItem.Checked = false;
            }

            panel1.Invalidate();
        }
	}
}
