using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using System.Drawing.Imaging;
using System.Drawing.Printing;

namespace _15_Images
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class Form1 : System.Windows.Forms.Form
	{
        private System.Windows.Forms.MainMenu mainMenu1;
        private System.Windows.Forms.MenuItem menuItem1;
        private System.Windows.Forms.MenuItem menuOpen;
        private System.Windows.Forms.MenuItem menuExit;
        private System.Windows.Forms.MenuItem menuItem4;
        private System.Windows.Forms.MenuItem menuRotate;
        private System.Windows.Forms.MenuItem menuScale;
        private System.Windows.Forms.MenuItem menuSave;
        private System.Windows.Forms.MenuItem menuItem8;
        private System.Windows.Forms.OpenFileDialog openFileDialog1;
        private System.Windows.Forms.SaveFileDialog saveFileDialog1;

        private Image image = null;
        private System.Windows.Forms.MenuItem menuCrop;
        private Rectangle cropRect = new Rectangle(-1,-1,-1,-1);
        private bool cropping = false;
        private bool animating = false;
        private System.Windows.Forms.MenuItem menuProperties;
        private System.Windows.Forms.MenuItem menuPrint;
        private System.Windows.Forms.MenuItem menuPrintPreview;
        private PageSettings printSettings = null;

		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public Form1()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();
            SetStyle(ControlStyles.UserPaint, true);
            SetStyle(ControlStyles.AllPaintingInWmPaint, true);
            SetStyle(ControlStyles.DoubleBuffer, true);

            foreach( string rotateName in Enum.GetNames( typeof(RotateFlipType) ))
            {
                menuRotate.MenuItems.Add( rotateName, new EventHandler(menuRotateOption_Click) );
            }
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

        protected override void OnPaint(PaintEventArgs e)
        {
            if( image == null )
            {
                return;
            }

            if( animating == true )
                ImageAnimator.UpdateFrames();

            e.Graphics.DrawImage( image, new Rectangle(0,0,image.Width, image.Height), 0, 0, image.Width, image.Height, GraphicsUnit.Pixel );

            if( cropping == true && cropRect.X != -1 && cropRect.Y != -1 )
            {
                // draw crop rect
                e.Graphics.DrawRectangle( new Pen( new SolidBrush(Color.Yellow)), cropRect );
            }
        }


		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
            this.mainMenu1 = new System.Windows.Forms.MainMenu();
            this.menuItem1 = new System.Windows.Forms.MenuItem();
            this.menuOpen = new System.Windows.Forms.MenuItem();
            this.menuSave = new System.Windows.Forms.MenuItem();
            this.menuPrint = new System.Windows.Forms.MenuItem();
            this.menuItem8 = new System.Windows.Forms.MenuItem();
            this.menuExit = new System.Windows.Forms.MenuItem();
            this.menuItem4 = new System.Windows.Forms.MenuItem();
            this.menuProperties = new System.Windows.Forms.MenuItem();
            this.menuRotate = new System.Windows.Forms.MenuItem();
            this.menuScale = new System.Windows.Forms.MenuItem();
            this.menuCrop = new System.Windows.Forms.MenuItem();
            this.openFileDialog1 = new System.Windows.Forms.OpenFileDialog();
            this.saveFileDialog1 = new System.Windows.Forms.SaveFileDialog();
            this.menuPrintPreview = new System.Windows.Forms.MenuItem();
            // 
            // mainMenu1
            // 
            this.mainMenu1.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
                                                                                      this.menuItem1,
                                                                                      this.menuItem4});
            // 
            // menuItem1
            // 
            this.menuItem1.Index = 0;
            this.menuItem1.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
                                                                                      this.menuOpen,
                                                                                      this.menuSave,
                                                                                      this.menuPrintPreview,
                                                                                      this.menuPrint,
                                                                                      this.menuItem8,
                                                                                      this.menuExit});
            this.menuItem1.Text = "File";
            // 
            // menuOpen
            // 
            this.menuOpen.Index = 0;
            this.menuOpen.Text = "&Open";
            this.menuOpen.Click += new System.EventHandler(this.menuOpen_Click);
            // 
            // menuSave
            // 
            this.menuSave.Index = 1;
            this.menuSave.Text = "&Save As";
            this.menuSave.Click += new System.EventHandler(this.menuSave_Click);
            // 
            // menuPrint
            // 
            this.menuPrint.Index = 3;
            this.menuPrint.Text = "Print";
            this.menuPrint.Click += new System.EventHandler(this.menuPrint_Click);
            // 
            // menuItem8
            // 
            this.menuItem8.Index = 4;
            this.menuItem8.Text = "-";
            // 
            // menuExit
            // 
            this.menuExit.Index = 5;
            this.menuExit.Text = "E&xit";
            this.menuExit.Click += new System.EventHandler(this.menuExit_Click);
            // 
            // menuItem4
            // 
            this.menuItem4.Index = 1;
            this.menuItem4.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
                                                                                      this.menuProperties,
                                                                                      this.menuRotate,
                                                                                      this.menuScale,
                                                                                      this.menuCrop});
            this.menuItem4.Text = "&Tools";
            // 
            // menuProperties
            // 
            this.menuProperties.Index = 0;
            this.menuProperties.Text = "Properties";
            this.menuProperties.Click += new System.EventHandler(this.menuProperties_Click);
            // 
            // menuRotate
            // 
            this.menuRotate.Index = 1;
            this.menuRotate.Text = "Rotate";
            // 
            // menuScale
            // 
            this.menuScale.Index = 2;
            this.menuScale.Text = "Scale";
            this.menuScale.Click += new System.EventHandler(this.menuScale_Click);
            // 
            // menuCrop
            // 
            this.menuCrop.Index = 3;
            this.menuCrop.Text = "Crop";
            this.menuCrop.Click += new System.EventHandler(this.menuCrop_Click);
            // 
            // openFileDialog1
            // 
            this.openFileDialog1.Filter = "Image Files(*.BMP;*.JPG;*.GIF;*.PNG)|*.BMP;*.JPG;*.GIF;*.PNG";
            // 
            // saveFileDialog1
            // 
            this.saveFileDialog1.Filter = "Image Files(*.BMP;*.JPG;*.GIF;*.PNG)|*.BMP;*.JPG;*.GIF;*.PNG";
            // 
            // menuPrintPreview
            // 
            this.menuPrintPreview.Index = 2;
            this.menuPrintPreview.Text = "Print Preview";
            this.menuPrintPreview.Click += new System.EventHandler(this.menuPrintPreview_Click);
            // 
            // Form1
            // 
            this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
            this.ClientSize = new System.Drawing.Size(592, 457);
            this.Cursor = System.Windows.Forms.Cursors.Default;
            this.Menu = this.mainMenu1;
            this.Name = "Form1";
            this.Text = "Image Test";
            this.MouseDown += new System.Windows.Forms.MouseEventHandler(this.Form1_MouseDown);
            this.MouseUp += new System.Windows.Forms.MouseEventHandler(this.Form1_MouseUp);
            this.MouseMove += new System.Windows.Forms.MouseEventHandler(this.Form1_MouseMove);

        }
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new Form1());
		}

        private void menuOpen_Click(object sender, System.EventArgs e)
        {
            if( openFileDialog1.ShowDialog() == DialogResult.OK )
            {
                image = Image.FromFile( openFileDialog1.FileName );
                this.Text = "Image Test - " + openFileDialog1.FileName;

                // check if animated image
                if( ImageAnimator.CanAnimate( image ) == true )
                {
                    animating = true;
                    ImageAnimator.Animate(image, new EventHandler(this.OnImageAnimate));
                }
                else
                {
                    animating = false;
                }
                Invalidate();
            }
        }

        private void OnImageAnimate(object o, EventArgs e) 
        {
            //Force a call to the Paint event handler.
            this.Invalidate();
        }

        private void Form1_MouseDown(object sender, System.Windows.Forms.MouseEventArgs e)
        {
            if( cropping == true )
            {
                cropRect.X = e.X;
                cropRect.Y = e.Y;
            }
        }

        private void menuCrop_Click(object sender, System.EventArgs e)
        {
            if( image != null )
            {
                this.Cursor = Cursors.Cross;   
                cropping = true;
            }
        }

        private void Form1_MouseMove(object sender, System.Windows.Forms.MouseEventArgs e)
        {
            if( cropping == true )
            {
                cropRect.Width = e.X - cropRect.X;
                cropRect.Height = e.Y - cropRect.Y;
                Invalidate();
            }
        }

        private void Form1_MouseUp(object sender, System.Windows.Forms.MouseEventArgs e)
        {
            if( cropping == true )
            {
                cropping = false;

                // move old picture
                Image oldImage = (Image) image.Clone();

                // create new image object
                image = new Bitmap( cropRect.Width, cropRect.Height );

                // get graphics object from new image
                Graphics g = Graphics.FromImage( image );

                // draw old image into new image using crop rect
                g.DrawImage( oldImage, new Rectangle(0,0,image.Width, image.Height), cropRect.X, cropRect.Y, cropRect.Width, cropRect.Height, GraphicsUnit.Pixel );

                // reset
                cropRect.X = cropRect.Y = -1;
                this.Cursor = Cursors.Default;
                Invalidate();
            }
        }

        private void menuRotateOption_Click( object sender, System.EventArgs e )
        {
            if( image != null )
            {
                image.RotateFlip( (RotateFlipType)Enum.Parse( typeof(RotateFlipType), ((MenuItem)sender).Text ));
                Invalidate();
            }
        }

        private void menuScale_Click(object sender, System.EventArgs e)
        {
            if( image == null )
                return;

            ScaleImageForm scale = new ScaleImageForm();
            if( scale.ShowDialog(this) == DialogResult.OK )
            {
                int newHeight = (int)(image.Height * (scale.ScaleHeight/100.0f));
                int newWidth = (int)(image.Width * (scale.ScaleWidth/100.0f));

                Image oldImage = (Image) image.Clone();
                image = new Bitmap( newWidth, newHeight );
                Graphics g = Graphics.FromImage( image );
                g.DrawImage( oldImage, new Rectangle(0,0,image.Width, image.Height), 0, 0, oldImage.Width, oldImage.Height, GraphicsUnit.Pixel );
                Invalidate();
            }
        }

        private void menuSave_Click(object sender, System.EventArgs e)
        {
            if( image == null )
                return;

            if( saveFileDialog1.ShowDialog(this) == DialogResult.OK )
            {
                ImageFormat format = ImageFormat.Bmp;

                if( saveFileDialog1.FileName.EndsWith("bmp"))
                {
                    format = ImageFormat.Bmp;
                }
                else if( saveFileDialog1.FileName.EndsWith("gif"))
                {
                    format = ImageFormat.Gif;
                }
                else if( saveFileDialog1.FileName.EndsWith("jpg"))
                {
                    format = ImageFormat.Jpeg;
                }
                else if( saveFileDialog1.FileName.EndsWith("png"))
                {
                    format = ImageFormat.Png;
                }

                image.Save( saveFileDialog1.FileName, format );
                image = Image.FromFile( saveFileDialog1.FileName );
                this.Text = "Image Test - " + saveFileDialog1.FileName;
            }
        }

        private void menuExit_Click(object sender, System.EventArgs e)
        {
            this.Close();
        }

        private void menuProperties_Click(object sender, System.EventArgs e)
        {
            if( image == null )
                return;

            ObjectInspector inspector = new ObjectInspector();
            inspector.propertyGrid1.SelectedObject = image;
            inspector.ShowDialog();
        }

        private void menuPrint_Click(object sender, System.EventArgs e)
        {
            if( image == null )
                return;

            PrintDialog dlg = new PrintDialog();
            dlg.AllowSelection = false;
            dlg.AllowSomePages = false;
            
            ImagePrintDocument doc = new ImagePrintDocument( image );
            dlg.Document = doc;
            
            if( dlg.ShowDialog() == DialogResult.OK )
            {
                doc.PrinterSettings = dlg.PrinterSettings;
                doc.Print();
            }
        }

        private void menuPrintPreview_Click(object sender, System.EventArgs e)
        {
            if( image == null )
                return;

            PrintPreviewDialog dlg = new PrintPreviewDialog() ;
            ImagePrintDocument doc = new ImagePrintDocument( image );
            dlg.Document = doc;
            dlg.ShowDialog(this);
        }
	}

    public class ImagePrintDocument : PrintDocument
    {
        private Image document;

        public ImagePrintDocument( Image doc )
        {
            this.document = doc;
        }

        protected override void OnPrintPage(PrintPageEventArgs e)
        {
            // calculate information string and update header height
            int headerHeight = e.MarginBounds.Y;
            SizeF strSize = e.Graphics.MeasureString( "Visual C# .Net Developer's Cookbook Chapter 10", new Font("Times New Roman", 12), e.MarginBounds.Width);
            headerHeight += (int) strSize.Height;

            // draw the info string
            e.Graphics.DrawString( "Visual C# .Net Developer's Cookbook Chapter 10", new Font("Times New Roman", 12), new SolidBrush(Color.Blue ), new RectangleF(e.MarginBounds.X, e.MarginBounds.Y, strSize.Width, strSize.Height));

            // draw a line under the string
            e.Graphics.DrawLine( new Pen( new SolidBrush(Color.Black)), e.MarginBounds.X, headerHeight+5, e.MarginBounds.Width+e.MarginBounds.X, headerHeight+5 );

            headerHeight += 10;

            // computer rectangle for image so its centered on page
            Rectangle rcImage = new Rectangle(0,0,0,0);
            
            if( document.Width >= e.MarginBounds.Width )
            {
                rcImage.X = e.MarginBounds.X;
                rcImage.Width = e.MarginBounds.Width;
            }
            else
            {
                // image width is smaller than printed page so center it
                rcImage.X = (int)((e.MarginBounds.Width/2)-(document.Width/2) + e.MarginBounds.X);
                rcImage.Width = document.Width;
            }
            if( document.Height >= e.MarginBounds.Height-headerHeight)
            {
                rcImage.Y = (int)(e.MarginBounds.Y + strSize.Height+20);
                rcImage.Height = (int)(e.MarginBounds.Height)-headerHeight;
            }
            else
            {
                // image width is smaller than printed page so center it
                rcImage.Y = (int)((e.MarginBounds.Height/2)-(document.Height/2));
                rcImage.Height = document.Height;
            }

            e.Graphics.DrawImage( document, rcImage, 0, 0, document.Width, document.Height, GraphicsUnit.Pixel );

            e.HasMorePages = false;
        }

    }
}
