using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using System.Drawing.Drawing2D;

namespace _5_LinearGradientBrush
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class Form1 : System.Windows.Forms.Form
	{
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;
        private System.Windows.Forms.Label label1;
        private System.Windows.Forms.Label label2;
        private LinearGradientBrush brush;
        private System.Windows.Forms.TrackBar tbFactors;
        private System.Windows.Forms.TrackBar tbPositions;
        private System.Windows.Forms.Panel panel1;
        private System.Windows.Forms.ColorDialog colorDialog1;
        private System.Windows.Forms.Panel panelStartColor;
        private System.Windows.Forms.Label label3;
        private System.Windows.Forms.Label label4;
        private System.Windows.Forms.Panel panelEndColor;
        private System.Windows.Forms.Label label5;
        private System.Windows.Forms.TrackBar tbAngle;
        private Blend gradientBlend;
        private System.Windows.Forms.Label lblAngle;
        private System.Windows.Forms.Label lblFactors;
        private System.Windows.Forms.Label lblPositions;
        private float angle = 45.0f;

		public Form1()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

            // create blend
            gradientBlend = new Blend(3);
            gradientBlend.Positions[0] = gradientBlend.Factors[0] = 0.0f;
            gradientBlend.Positions[1] = gradientBlend.Factors[1] = 0.4f;
            gradientBlend.Positions[2] = gradientBlend.Factors[2] = 1.0f;
            
            panelStartColor.BackColor = Color.Blue;
            panelEndColor.BackColor = Color.Red;
            
            // create brush
            brush = new LinearGradientBrush(new Rectangle(new Point(0,0), new Size(panel1.Width, panel1.Height)), Color.Blue, Color.Red, angle );
            
            // set trackbars to blend values
            tbFactors.Value = 40;
            tbPositions.Value = 40;
            tbPositions.Value = 45;
            tbAngle.Value = 0;


		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
            this.tbFactors = new System.Windows.Forms.TrackBar();
            this.tbPositions = new System.Windows.Forms.TrackBar();
            this.label1 = new System.Windows.Forms.Label();
            this.label2 = new System.Windows.Forms.Label();
            this.panel1 = new System.Windows.Forms.Panel();
            this.colorDialog1 = new System.Windows.Forms.ColorDialog();
            this.panelStartColor = new System.Windows.Forms.Panel();
            this.label3 = new System.Windows.Forms.Label();
            this.label4 = new System.Windows.Forms.Label();
            this.panelEndColor = new System.Windows.Forms.Panel();
            this.label5 = new System.Windows.Forms.Label();
            this.tbAngle = new System.Windows.Forms.TrackBar();
            this.lblAngle = new System.Windows.Forms.Label();
            this.lblFactors = new System.Windows.Forms.Label();
            this.lblPositions = new System.Windows.Forms.Label();
            ((System.ComponentModel.ISupportInitialize)(this.tbFactors)).BeginInit();
            ((System.ComponentModel.ISupportInitialize)(this.tbPositions)).BeginInit();
            ((System.ComponentModel.ISupportInitialize)(this.tbAngle)).BeginInit();
            this.SuspendLayout();
            // 
            // tbFactors
            // 
            this.tbFactors.Location = new System.Drawing.Point(296, 24);
            this.tbFactors.Maximum = 100;
            this.tbFactors.Name = "tbFactors";
            this.tbFactors.Size = new System.Drawing.Size(144, 45);
            this.tbFactors.TabIndex = 0;
            this.tbFactors.TickFrequency = 10;
            this.tbFactors.ValueChanged += new System.EventHandler(this.tbFactors_ValueChanged);
            // 
            // tbPositions
            // 
            this.tbPositions.Location = new System.Drawing.Point(448, 24);
            this.tbPositions.Maximum = 100;
            this.tbPositions.Name = "tbPositions";
            this.tbPositions.Size = new System.Drawing.Size(144, 45);
            this.tbPositions.TabIndex = 1;
            this.tbPositions.TickFrequency = 10;
            this.tbPositions.ValueChanged += new System.EventHandler(this.tbPositions_ValueChanged);
            // 
            // label1
            // 
            this.label1.Location = new System.Drawing.Point(304, 8);
            this.label1.Name = "label1";
            this.label1.Size = new System.Drawing.Size(100, 16);
            this.label1.TabIndex = 2;
            this.label1.Text = "Factors";
            // 
            // label2
            // 
            this.label2.Location = new System.Drawing.Point(456, 16);
            this.label2.Name = "label2";
            this.label2.Size = new System.Drawing.Size(100, 16);
            this.label2.TabIndex = 3;
            this.label2.Text = "Positions";
            // 
            // panel1
            // 
            this.panel1.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
                | System.Windows.Forms.AnchorStyles.Left) 
                | System.Windows.Forms.AnchorStyles.Right)));
            this.panel1.Location = new System.Drawing.Point(8, 96);
            this.panel1.Name = "panel1";
            this.panel1.Size = new System.Drawing.Size(592, 320);
            this.panel1.TabIndex = 4;
            this.panel1.Paint += new System.Windows.Forms.PaintEventHandler(this.panel1_Paint);
            // 
            // panelStartColor
            // 
            this.panelStartColor.Location = new System.Drawing.Point(16, 24);
            this.panelStartColor.Name = "panelStartColor";
            this.panelStartColor.Size = new System.Drawing.Size(40, 40);
            this.panelStartColor.TabIndex = 5;
            this.panelStartColor.Click += new System.EventHandler(this.panelStartColor_Click);
            // 
            // label3
            // 
            this.label3.Location = new System.Drawing.Point(8, 8);
            this.label3.Name = "label3";
            this.label3.Size = new System.Drawing.Size(64, 16);
            this.label3.TabIndex = 6;
            this.label3.Text = "Start Color";
            // 
            // label4
            // 
            this.label4.Location = new System.Drawing.Point(96, 8);
            this.label4.Name = "label4";
            this.label4.Size = new System.Drawing.Size(56, 16);
            this.label4.TabIndex = 7;
            this.label4.Text = "End Color";
            // 
            // panelEndColor
            // 
            this.panelEndColor.Location = new System.Drawing.Point(104, 24);
            this.panelEndColor.Name = "panelEndColor";
            this.panelEndColor.Size = new System.Drawing.Size(40, 40);
            this.panelEndColor.TabIndex = 8;
            this.panelEndColor.Click += new System.EventHandler(this.panelEndColor_Click);
            // 
            // label5
            // 
            this.label5.Location = new System.Drawing.Point(160, 8);
            this.label5.Name = "label5";
            this.label5.Size = new System.Drawing.Size(40, 16);
            this.label5.TabIndex = 9;
            this.label5.Text = "Angle";
            // 
            // tbAngle
            // 
            this.tbAngle.Location = new System.Drawing.Point(152, 24);
            this.tbAngle.Maximum = 359;
            this.tbAngle.Name = "tbAngle";
            this.tbAngle.Size = new System.Drawing.Size(144, 45);
            this.tbAngle.TabIndex = 10;
            this.tbAngle.TickFrequency = 30;
            this.tbAngle.ValueChanged += new System.EventHandler(this.tbAngle_ValueChanged);
            // 
            // lblAngle
            // 
            this.lblAngle.Location = new System.Drawing.Point(160, 72);
            this.lblAngle.Name = "lblAngle";
            this.lblAngle.Size = new System.Drawing.Size(128, 16);
            this.lblAngle.TabIndex = 11;
            this.lblAngle.Text = "0";
            this.lblAngle.TextAlign = System.Drawing.ContentAlignment.TopCenter;
            // 
            // lblFactors
            // 
            this.lblFactors.Location = new System.Drawing.Point(304, 72);
            this.lblFactors.Name = "lblFactors";
            this.lblFactors.Size = new System.Drawing.Size(128, 16);
            this.lblFactors.TabIndex = 12;
            this.lblFactors.Text = "0";
            this.lblFactors.TextAlign = System.Drawing.ContentAlignment.TopCenter;
            // 
            // lblPositions
            // 
            this.lblPositions.Location = new System.Drawing.Point(456, 72);
            this.lblPositions.Name = "lblPositions";
            this.lblPositions.Size = new System.Drawing.Size(128, 16);
            this.lblPositions.TabIndex = 13;
            this.lblPositions.Text = "0";
            this.lblPositions.TextAlign = System.Drawing.ContentAlignment.TopCenter;
            // 
            // Form1
            // 
            this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
            this.ClientSize = new System.Drawing.Size(608, 422);
            this.Controls.Add(this.lblPositions);
            this.Controls.Add(this.lblFactors);
            this.Controls.Add(this.lblAngle);
            this.Controls.Add(this.tbAngle);
            this.Controls.Add(this.label5);
            this.Controls.Add(this.panelEndColor);
            this.Controls.Add(this.label4);
            this.Controls.Add(this.label3);
            this.Controls.Add(this.panelStartColor);
            this.Controls.Add(this.panel1);
            this.Controls.Add(this.label2);
            this.Controls.Add(this.label1);
            this.Controls.Add(this.tbPositions);
            this.Controls.Add(this.tbFactors);
            this.Name = "Form1";
            this.Text = "Linear Gradient Brush Test";
            ((System.ComponentModel.ISupportInitialize)(this.tbFactors)).EndInit();
            ((System.ComponentModel.ISupportInitialize)(this.tbPositions)).EndInit();
            ((System.ComponentModel.ISupportInitialize)(this.tbAngle)).EndInit();
            this.ResumeLayout(false);

        }
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new Form1());
		}

        private void tbFactors_ValueChanged(object sender, System.EventArgs e)
        {
            gradientBlend.Factors[1] = tbFactors.Value/100.0f;
            brush.Blend = gradientBlend;
            panel1.Invalidate();

            lblFactors.Text = "";
            foreach( float val in gradientBlend.Factors )
            {
                lblFactors.Text += "[" + (val/100).ToString() + "] ";
            }
        }

        private void tbPositions_ValueChanged(object sender, System.EventArgs e)
        {
            gradientBlend.Positions[1] = tbPositions.Value/100.0f;
            brush.Blend = gradientBlend;
            panel1.Invalidate();

            lblPositions.Text = "";
            foreach( float val in gradientBlend.Positions )
            {
                lblPositions.Text += "[" + (val/100).ToString() + "] ";
            }
        }

        private void panel1_Paint(object sender, System.Windows.Forms.PaintEventArgs e)
        {
            e.Graphics.FillRectangle( brush, 0, 0, panel1.Width, panel1.Height );
        }

        private void panelStartColor_Click(object sender, System.EventArgs e)
        {
            if( colorDialog1.ShowDialog() == DialogResult.OK )
            {
                panelStartColor.BackColor = colorDialog1.Color;
                brush = new LinearGradientBrush(new Rectangle(new Point(0,0), new Size(panel1.Width, panel1.Height)), panelStartColor.BackColor, panelEndColor.BackColor, angle );
                brush.Blend = gradientBlend;
                panel1.Invalidate();
            }
        }

        private void panelEndColor_Click(object sender, System.EventArgs e)
        {
            if( colorDialog1.ShowDialog() == DialogResult.OK )
            {
                panelEndColor.BackColor = colorDialog1.Color;
                brush = new LinearGradientBrush(new Rectangle(new Point(0,0), new Size(panel1.Width, panel1.Height)), panelStartColor.BackColor, panelEndColor.BackColor, angle );
                brush.Blend = gradientBlend;
                panel1.Invalidate();
            }
        }

        private void tbAngle_ValueChanged(object sender, System.EventArgs e)
        {
            angle = tbAngle.Value;
            brush = new LinearGradientBrush(new Rectangle(new Point(0,0), new Size(panel1.Width, panel1.Height)), panelStartColor.BackColor, panelEndColor.BackColor, angle );
            brush.Blend = gradientBlend;
            panel1.Invalidate();

            lblAngle.Text = angle.ToString();
        }
	}
}
