using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;

namespace _6_LinesAndPolygons
{
    /// <summary>
    /// Summary description for Form1.
    /// </summary>
    public class Form1 : System.Windows.Forms.Form
    {
        private System.Windows.Forms.Label label1;
        private System.Windows.Forms.Panel panel1;
        private Point lastPoint = new Point(-1,-1);
        private ArrayList alPoints;

		/// <summary>
		/// Required designer variable.
		/// </summary>
        private System.ComponentModel.Container components = null;

        public Form1()
        {
            //
            // Required for Windows Form Designer support
            //
            InitializeComponent();

            alPoints = new ArrayList();
        }

        /// <summary>
        /// Clean up any resources being used.
        /// </summary>
        protected override void Dispose( bool disposing )
        {
            if( disposing )
            {
                if (components != null) 
                {
                    components.Dispose();
                }
            }
            base.Dispose( disposing );
        }

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
            this.label1 = new System.Windows.Forms.Label();
            this.panel1 = new System.Windows.Forms.Panel();
            this.SuspendLayout();
            // 
            // label1
            // 
            this.label1.Dock = System.Windows.Forms.DockStyle.Top;
            this.label1.Font = new System.Drawing.Font("Microsoft Sans Serif", 12F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
            this.label1.Location = new System.Drawing.Point(0, 0);
            this.label1.Name = "label1";
            this.label1.Size = new System.Drawing.Size(464, 23);
            this.label1.TabIndex = 0;
            this.label1.Text = "Left click to add points.  Right click to close polygon.";
            this.label1.TextAlign = System.Drawing.ContentAlignment.MiddleCenter;
            // 
            // panel1
            // 
            this.panel1.Dock = System.Windows.Forms.DockStyle.Fill;
            this.panel1.Location = new System.Drawing.Point(0, 23);
            this.panel1.Name = "panel1";
            this.panel1.Size = new System.Drawing.Size(464, 335);
            this.panel1.TabIndex = 1;
            this.panel1.MouseDown += new System.Windows.Forms.MouseEventHandler(this.panel1_MouseDown);
            // 
            // Form1
            // 
            this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
            this.ClientSize = new System.Drawing.Size(464, 358);
            this.Controls.Add(this.panel1);
            this.Controls.Add(this.label1);
            this.Name = "Form1";
            this.Text = "Lines and Polygon Test";
            this.ResumeLayout(false);

        }
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new Form1());
		}

        private void panel1_MouseDown(object sender, System.Windows.Forms.MouseEventArgs e)
        {
            Graphics g = panel1.CreateGraphics();
            Random rand = new Random( DateTime.Now.Millisecond );

            int rc = rand.Next(255);
            int gc = rand.Next(255);
            int bc = rand.Next(255);

            if( e.Button == MouseButtons.Left )
            {
                g.FillRectangle( new SolidBrush(Color.Black), e.X, e.Y, 5, 5 );

                if( lastPoint.X != -1 && lastPoint.Y != -1 )
                {
                    g.DrawLine( new Pen(new SolidBrush(Color.Black)), lastPoint, new Point(e.X, e.Y ));
                }

                lastPoint.X = e.X;
                lastPoint.Y = e.Y;

                alPoints.Add( lastPoint );
            }
            else if( e.Button == MouseButtons.Right )
            {
                Point[] points = (Point[]) alPoints.ToArray( typeof(Point));

                if( rand.Next(2) == 0 )
                {
                    g.DrawPolygon( new Pen( new SolidBrush(Color.FromArgb(rc,gc,bc ))), points );
                }
                else
                {
                    g.FillPolygon( new SolidBrush( Color.FromArgb(rc,gc,bc )), points );
                }
                alPoints.Clear();
                lastPoint.X = -1;
                lastPoint.Y = -1;
            }

            g.Dispose();
        }
	}
}
