using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using System.Drawing.Drawing2D;

namespace _8_RotationAndTranslation
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class Form1 : System.Windows.Forms.Form
	{
        private System.Windows.Forms.Timer timer1;
        private System.ComponentModel.IContainer components;
        private float curRotation = 0.0f;
        private float dx = 10.0f;
        private float dy = 5.0f;
        
        private Matrix curTransform;
        private bool enableContainer = true;
        private System.Windows.Forms.MainMenu mainMenu1;
        private System.Windows.Forms.MenuItem menuItem1;
        private System.Windows.Forms.MenuItem menuContainer;
        private System.Windows.Forms.MenuItem menuFlickerFree;
        
        public Form1()
		{
			InitializeComponent(); 

            // enable flicker free drawing
            SetStyle(ControlStyles.UserPaint | ControlStyles.AllPaintingInWmPaint| ControlStyles.DoubleBuffer, true);

            Graphics g = this.CreateGraphics();
            curTransform = g.Transform;
            curTransform.Translate( this.Width/2.0f, this.Height/2.0f );
            
            timer1.Start();
            g.Dispose();
		}

        protected override void OnPaint(PaintEventArgs e)
        { 
            GraphicsContainer container = null;
            if( enableContainer == true )
                container = e.Graphics.BeginContainer();
            
            if( curTransform.OffsetX >= this.Width-40 )
                dx = -dx;
            if( curTransform.OffsetX <= 0+20 )
                dx = -dx;
            if( curTransform.OffsetY >= this.Height-80 )
                dy = -dy;
            if( curTransform.OffsetY <= 0+40 )
                dy = -dy;
        
            curTransform.Translate( dx, dy );
            e.Graphics.Transform = curTransform;
           
            e.Graphics.RotateTransform(curRotation);
            
            DrawStar( e.Graphics );

            if( enableContainer == true )
                e.Graphics.EndContainer( container );
             
            e.Graphics.DrawString("Rotation and Translation Test", new Font("Times New Roman", 24), new SolidBrush(Color.Blue ), new RectangleF(10, 10, this.Width-10, this.Height-10/2));
        }

        private void DrawStar( Graphics g )
        {
            GraphicsContainer container = g.BeginContainer();

            Point[] starPoints = { new Point(-20,0), new Point(20,0), new Point(0,40), new Point(-20,0)};

            for( int i = 0; i < 8; i++ )
            {
                g.FillPolygon( new SolidBrush(Color.Red), starPoints );
                g.DrawPolygon( new Pen(new SolidBrush(Color.Black)), starPoints );
                
                g.RotateTransform( 45.0f );
            }

            g.EndContainer( container );
        }

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
            this.components = new System.ComponentModel.Container();
            this.timer1 = new System.Windows.Forms.Timer(this.components);
            this.mainMenu1 = new System.Windows.Forms.MainMenu();
            this.menuItem1 = new System.Windows.Forms.MenuItem();
            this.menuContainer = new System.Windows.Forms.MenuItem();
            this.menuFlickerFree = new System.Windows.Forms.MenuItem();
            // 
            // timer1
            // 
            this.timer1.Tick += new System.EventHandler(this.timer1_Tick);
            // 
            // mainMenu1
            // 
            this.mainMenu1.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
                                                                                      this.menuItem1});
            // 
            // menuItem1
            // 
            this.menuItem1.Index = 0;
            this.menuItem1.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
                                                                                      this.menuContainer,
                                                                                      this.menuFlickerFree});
            this.menuItem1.Text = "Options";
            // 
            // menuContainer
            // 
            this.menuContainer.Checked = true;
            this.menuContainer.Index = 0;
            this.menuContainer.Text = "Enable Container";
            this.menuContainer.Click += new System.EventHandler(this.menuContainer_Click);
            // 
            // menuFlickerFree
            // 
            this.menuFlickerFree.Checked = true;
            this.menuFlickerFree.Index = 1;
            this.menuFlickerFree.Text = "Flicker Free";
            this.menuFlickerFree.Click += new System.EventHandler(this.menuFlickerFree_Click);
            // 
            // Form1
            // 
            this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
            this.ClientSize = new System.Drawing.Size(416, 310);
            this.Menu = this.mainMenu1;
            this.Name = "Form1";
            this.Text = "Rotation and Translation Test";

        }
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new Form1());
		}

        private void timer1_Tick(object sender, System.EventArgs e)
        {
            curRotation += 30;
            if( curRotation > 360 )
                curRotation = 0;

            this.Invalidate();
        }

        private void menuContainer_Click(object sender, System.EventArgs e)
        {
            if( menuContainer.Checked == true )
            {
                menuContainer.Checked = false;
                enableContainer = false;
            }
            else
            {
                menuContainer.Checked = true;
                enableContainer = true;
            }
        }

        private void menuFlickerFree_Click(object sender, System.EventArgs e)
        {
            if( menuFlickerFree.Checked == true )
            {
                menuFlickerFree.Checked = false;
                SetStyle(ControlStyles.AllPaintingInWmPaint, false);
                SetStyle(ControlStyles.DoubleBuffer, false);
            }
            else
            {
                menuFlickerFree.Checked = true;
                SetStyle( ControlStyles.UserPaint, true );
                SetStyle(ControlStyles.AllPaintingInWmPaint, true);
                SetStyle(ControlStyles.DoubleBuffer, true);
            }
        }
	}
}
