using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using System.Resources;
using _11_ResourceObjects;

namespace _11_ImageCaptionViewer
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class Form1 : System.Windows.Forms.Form
	{
        private System.Windows.Forms.PictureBox pbImage;
        private System.Windows.Forms.Label lblCaption;
        private System.Windows.Forms.Button btnPrev;
        private System.Windows.Forms.Button btnNext;
        ArrayList alImages;
        private System.Windows.Forms.MainMenu mainMenu1;
        private System.Windows.Forms.MenuItem menuItem1;
        private System.Windows.Forms.MenuItem mnuOpen;
        private System.Windows.Forms.OpenFileDialog openFileDialog1;
        private int currentIdx = 0;

		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public Form1()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();
            alImages = new ArrayList();
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
            this.pbImage = new System.Windows.Forms.PictureBox();
            this.lblCaption = new System.Windows.Forms.Label();
            this.btnPrev = new System.Windows.Forms.Button();
            this.btnNext = new System.Windows.Forms.Button();
            this.mainMenu1 = new System.Windows.Forms.MainMenu();
            this.menuItem1 = new System.Windows.Forms.MenuItem();
            this.mnuOpen = new System.Windows.Forms.MenuItem();
            this.openFileDialog1 = new System.Windows.Forms.OpenFileDialog();
            this.SuspendLayout();
            // 
            // pbImage
            // 
            this.pbImage.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
            this.pbImage.Location = new System.Drawing.Point(44, 8);
            this.pbImage.Name = "pbImage";
            this.pbImage.Size = new System.Drawing.Size(352, 328);
            this.pbImage.SizeMode = System.Windows.Forms.PictureBoxSizeMode.StretchImage;
            this.pbImage.TabIndex = 0;
            this.pbImage.TabStop = false;
            // 
            // lblCaption
            // 
            this.lblCaption.BorderStyle = System.Windows.Forms.BorderStyle.Fixed3D;
            this.lblCaption.Font = new System.Drawing.Font("Microsoft Sans Serif", 12F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
            this.lblCaption.Location = new System.Drawing.Point(44, 344);
            this.lblCaption.Name = "lblCaption";
            this.lblCaption.Size = new System.Drawing.Size(352, 23);
            this.lblCaption.TabIndex = 1;
            this.lblCaption.TextAlign = System.Drawing.ContentAlignment.MiddleCenter;
            // 
            // btnPrev
            // 
            this.btnPrev.Location = new System.Drawing.Point(160, 384);
            this.btnPrev.Name = "btnPrev";
            this.btnPrev.Size = new System.Drawing.Size(48, 23);
            this.btnPrev.TabIndex = 2;
            this.btnPrev.Text = "<";
            this.btnPrev.Click += new System.EventHandler(this.btnPrev_Click);
            // 
            // btnNext
            // 
            this.btnNext.Location = new System.Drawing.Point(224, 384);
            this.btnNext.Name = "btnNext";
            this.btnNext.Size = new System.Drawing.Size(48, 23);
            this.btnNext.TabIndex = 3;
            this.btnNext.Text = ">";
            this.btnNext.Click += new System.EventHandler(this.btnNext_Click);
            // 
            // mainMenu1
            // 
            this.mainMenu1.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
                                                                                      this.menuItem1});
            // 
            // menuItem1
            // 
            this.menuItem1.Index = 0;
            this.menuItem1.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
                                                                                      this.mnuOpen});
            this.menuItem1.Text = "File";
            // 
            // mnuOpen
            // 
            this.mnuOpen.Index = 0;
            this.mnuOpen.Text = "&Open";
            this.mnuOpen.Click += new System.EventHandler(this.mnuOpen_Click);
            // 
            // openFileDialog1
            // 
            this.openFileDialog1.Filter = "Resources File|*.resources";
            // 
            // Form1
            // 
            this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
            this.ClientSize = new System.Drawing.Size(440, 430);
            this.Controls.Add(this.btnNext);
            this.Controls.Add(this.btnPrev);
            this.Controls.Add(this.lblCaption);
            this.Controls.Add(this.pbImage);
            this.Menu = this.mainMenu1;
            this.Name = "Form1";
            this.Text = "ImageCaption Resource Viewer";
            this.ResumeLayout(false);

        }
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new Form1());
		}

        private void mnuOpen_Click(object sender, System.EventArgs e)
        {
            if( openFileDialog1.ShowDialog() == DialogResult.OK )
            {
                ResourceReader rr = new ResourceReader( openFileDialog1.FileName );
                IDictionaryEnumerator en = rr.GetEnumerator();
      
                // Goes through the enumerator, printing out the key and value pairs.
                while (en.MoveNext()) 
                {
                    alImages.Add ((ImageWithCaption) en.Value);

                }
                rr.Close();
            }

            pbImage.Image = ((ImageWithCaption)alImages[0]).image;
            lblCaption.Text = ((ImageWithCaption)alImages[0]).Caption;

            currentIdx = 0;
        }

        private void btnPrev_Click(object sender, System.EventArgs e)
        {
            currentIdx--;
            if( currentIdx < 0 )
                currentIdx = alImages.Count - 1;

            pbImage.Image = ((ImageWithCaption) alImages[currentIdx]).image;
            lblCaption.Text = ((ImageWithCaption) alImages[currentIdx]).Caption;        
        }

        private void btnNext_Click(object sender, System.EventArgs e)
        {
            currentIdx++;
            if( currentIdx > alImages.Count - 1 )
                currentIdx = 0;

            pbImage.Image = ((ImageWithCaption) alImages[currentIdx]).image;
            lblCaption.Text = ((ImageWithCaption) alImages[currentIdx]).Caption;
        }
	}
}
