using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using System.Resources;
using System.Reflection;

namespace _11_ResourceWriter
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class Form1 : System.Windows.Forms.Form
	{
        private System.Windows.Forms.Button btnAdd;
        private System.Windows.Forms.ListView lvItems;
        private System.Windows.Forms.ColumnHeader columnHeader1;
        private System.Windows.Forms.ColumnHeader columnHeader2;
        private System.Windows.Forms.Button btnDelete;
        private System.Windows.Forms.Button btnSave;
        private System.Windows.Forms.SaveFileDialog saveFileDialog1;

		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public Form1()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
            this.btnAdd = new System.Windows.Forms.Button();
            this.lvItems = new System.Windows.Forms.ListView();
            this.columnHeader1 = new System.Windows.Forms.ColumnHeader();
            this.columnHeader2 = new System.Windows.Forms.ColumnHeader();
            this.btnDelete = new System.Windows.Forms.Button();
            this.btnSave = new System.Windows.Forms.Button();
            this.saveFileDialog1 = new System.Windows.Forms.SaveFileDialog();
            this.SuspendLayout();
            // 
            // btnAdd
            // 
            this.btnAdd.Location = new System.Drawing.Point(47, 160);
            this.btnAdd.Name = "btnAdd";
            this.btnAdd.TabIndex = 0;
            this.btnAdd.Text = "Add";
            this.btnAdd.Click += new System.EventHandler(this.btnAdd_Click);
            // 
            // lvItems
            // 
            this.lvItems.Columns.AddRange(new System.Windows.Forms.ColumnHeader[] {
                                                                                      this.columnHeader1,
                                                                                      this.columnHeader2});
            this.lvItems.Location = new System.Drawing.Point(8, 8);
            this.lvItems.Name = "lvItems";
            this.lvItems.Size = new System.Drawing.Size(344, 144);
            this.lvItems.TabIndex = 1;
            this.lvItems.View = System.Windows.Forms.View.Details;
            // 
            // columnHeader1
            // 
            this.columnHeader1.Text = "Caption";
            this.columnHeader1.Width = 100;
            // 
            // columnHeader2
            // 
            this.columnHeader2.Text = "Image Path";
            this.columnHeader2.Width = 200;
            // 
            // btnDelete
            // 
            this.btnDelete.Location = new System.Drawing.Point(143, 160);
            this.btnDelete.Name = "btnDelete";
            this.btnDelete.TabIndex = 2;
            this.btnDelete.Text = "Delete";
            this.btnDelete.Click += new System.EventHandler(this.btnDelete_Click);
            // 
            // btnSave
            // 
            this.btnSave.Location = new System.Drawing.Point(239, 160);
            this.btnSave.Name = "btnSave";
            this.btnSave.TabIndex = 3;
            this.btnSave.Text = "Save";
            this.btnSave.Click += new System.EventHandler(this.btnSave_Click);
            // 
            // saveFileDialog1
            // 
            this.saveFileDialog1.Filter = "Resources File|*.resources";
            // 
            // Form1
            // 
            this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
            this.ClientSize = new System.Drawing.Size(360, 190);
            this.Controls.Add(this.btnSave);
            this.Controls.Add(this.btnDelete);
            this.Controls.Add(this.lvItems);
            this.Controls.Add(this.btnAdd);
            this.Name = "Form1";
            this.Text = "Image Caption Resource Editor";
            this.ResumeLayout(false);

        }
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new Form1());
		}

        private void btnAdd_Click(object sender, System.EventArgs e)
        {
            NewImageCaption newImage = new NewImageCaption();
            if( newImage.ShowDialog() == DialogResult.OK )
            {
                ListViewItem lvItem = new ListViewItem( new string[]{newImage.Caption,newImage.ImagePath} );
                lvItems.Items.Add( lvItem );
            }
        }

        private void btnDelete_Click(object sender, System.EventArgs e)
        {
            lvItems.Items.Remove( lvItems.SelectedItems[0] );
        }

        private void btnSave_Click(object sender, System.EventArgs e)
        {
            if( saveFileDialog1.ShowDialog() == DialogResult.OK )
            {
                ResourceWriter rw = new ResourceWriter( saveFileDialog1.FileName );

                foreach( ListViewItem lvItem in lvItems.Items )
                {
                    _11_ResourceObjects.ImageWithCaption obj = new _11_ResourceObjects.ImageWithCaption( lvItem.SubItems[0].Text, Image.FromFile( lvItem.SubItems[1].Text ));
                    rw.AddResource( lvItem.SubItems[0].Text, obj );
                }

                rw.Generate();
            }
        }
	}
}
