using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using System.Globalization;

namespace _4_CultureTypes
{
	public class Form1 : System.Windows.Forms.Form
	{
        private System.Windows.Forms.Label label1;
        private System.Windows.Forms.Label label2;
        private System.Windows.Forms.Label label3;
        private System.Windows.Forms.Label label4;
        private System.Windows.Forms.ComboBox cbAll;
        private System.Windows.Forms.ComboBox cbNeutral;
        private System.Windows.Forms.ComboBox cbWin32;
        private System.Windows.Forms.ComboBox cbSpecific;

        private System.ComponentModel.Container components = null;

        public Form1()
        {
            InitializeComponent();

            foreach( CultureInfo curCI in CultureInfo.GetCultures( CultureTypes.AllCultures ))
            {
                cbAll.Items.Add( curCI.DisplayName );
            }
            foreach( CultureInfo curCI in CultureInfo.GetCultures( CultureTypes.InstalledWin32Cultures ))
            {
                cbWin32.Items.Add( curCI.DisplayName );
            }
            foreach( CultureInfo curCI in CultureInfo.GetCultures( CultureTypes.NeutralCultures ))
            {
                cbNeutral.Items.Add( curCI.DisplayName );
            }
            foreach( CultureInfo curCI in CultureInfo.GetCultures( CultureTypes.SpecificCultures ))
            {
                cbSpecific.Items.Add( curCI.DisplayName );
            }
        }

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
            this.label1 = new System.Windows.Forms.Label();
            this.label2 = new System.Windows.Forms.Label();
            this.label3 = new System.Windows.Forms.Label();
            this.label4 = new System.Windows.Forms.Label();
            this.cbAll = new System.Windows.Forms.ComboBox();
            this.cbNeutral = new System.Windows.Forms.ComboBox();
            this.cbWin32 = new System.Windows.Forms.ComboBox();
            this.cbSpecific = new System.Windows.Forms.ComboBox();
            this.SuspendLayout();
            // 
            // label1
            // 
            this.label1.Location = new System.Drawing.Point(8, 8);
            this.label1.Name = "label1";
            this.label1.Size = new System.Drawing.Size(100, 16);
            this.label1.TabIndex = 0;
            this.label1.Text = "All Cultures";
            // 
            // label2
            // 
            this.label2.Location = new System.Drawing.Point(8, 152);
            this.label2.Name = "label2";
            this.label2.Size = new System.Drawing.Size(100, 16);
            this.label2.TabIndex = 1;
            this.label2.Text = "Specific Cultures";
            // 
            // label3
            // 
            this.label3.Location = new System.Drawing.Point(8, 104);
            this.label3.Name = "label3";
            this.label3.Size = new System.Drawing.Size(100, 16);
            this.label3.TabIndex = 2;
            this.label3.Text = "Neutral Cultures";
            // 
            // label4
            // 
            this.label4.Location = new System.Drawing.Point(8, 56);
            this.label4.Name = "label4";
            this.label4.Size = new System.Drawing.Size(144, 16);
            this.label4.TabIndex = 3;
            this.label4.Text = "InstalledWin32Cultures";
            // 
            // cbAll
            // 
            this.cbAll.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
            this.cbAll.Location = new System.Drawing.Point(8, 24);
            this.cbAll.Name = "cbAll";
            this.cbAll.Size = new System.Drawing.Size(272, 21);
            this.cbAll.TabIndex = 4;
            // 
            // cbNeutral
            // 
            this.cbNeutral.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
            this.cbNeutral.Location = new System.Drawing.Point(8, 120);
            this.cbNeutral.Name = "cbNeutral";
            this.cbNeutral.Size = new System.Drawing.Size(272, 21);
            this.cbNeutral.TabIndex = 5;
            // 
            // cbWin32
            // 
            this.cbWin32.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
            this.cbWin32.Location = new System.Drawing.Point(8, 72);
            this.cbWin32.Name = "cbWin32";
            this.cbWin32.Size = new System.Drawing.Size(272, 21);
            this.cbWin32.TabIndex = 6;
            // 
            // cbSpecific
            // 
            this.cbSpecific.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
            this.cbSpecific.Location = new System.Drawing.Point(8, 168);
            this.cbSpecific.Name = "cbSpecific";
            this.cbSpecific.Size = new System.Drawing.Size(272, 21);
            this.cbSpecific.TabIndex = 7;
            // 
            // Form1
            // 
            this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
            this.ClientSize = new System.Drawing.Size(292, 206);
            this.Controls.Add(this.cbSpecific);
            this.Controls.Add(this.cbWin32);
            this.Controls.Add(this.cbNeutral);
            this.Controls.Add(this.cbAll);
            this.Controls.Add(this.label4);
            this.Controls.Add(this.label3);
            this.Controls.Add(this.label2);
            this.Controls.Add(this.label1);
            this.Name = "Form1";
            this.Text = "Culture Types";
            this.ResumeLayout(false);

        }
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new Form1());
		}
	}
}
