using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using System.Threading;
using System.Globalization;

namespace _6_CultureAwareControls
{
	public class Form1 : System.Windows.Forms.Form
	{
        private System.Windows.Forms.NumericUpDown numericUpDown1;
        private System.Windows.Forms.GroupBox groupBox1;
        private System.Windows.Forms.Label label1;
        private System.Windows.Forms.Label lblUpDown;
        private System.Windows.Forms.GroupBox groupBox3;
        private System.Windows.Forms.PropertyGrid pgNumberInfo;
        private System.Windows.Forms.Label label2;
        private System.Windows.Forms.Label label3;
        private System.Windows.Forms.Label lblCurrency;
        private System.Windows.Forms.PropertyGrid pgDateTime;
        private System.Windows.Forms.ComboBox cbLanguage;
        private System.Windows.Forms.Label label4;
        private NumberFormatInfo currentNFI;
        private DateTimeFormatInfo currentDTFI;
        private System.Windows.Forms.Label label5;
        private System.Windows.Forms.GroupBox groupBox2;
        private System.Windows.Forms.ComboBox cbDateTimeFormat;
        private System.Windows.Forms.Label label6;
        private System.Windows.Forms.Label lblDateTime;

		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public Form1()
		{
			InitializeComponent();

            // add languages
            foreach( CultureInfo curCI in CultureInfo.GetCultures( CultureTypes.SpecificCultures ))
            {
                cbLanguage.Items.Add( curCI.Name );    
            }
            
            // add datetime formats
            string[] formats = {"d", "D", "f", "F", "g", "G", "m", "M", "r", "R", "s", "t", "T", "u", "U", "y", "Y" };
            cbDateTimeFormat.Items.AddRange( formats );

            cbDateTimeFormat.SelectedIndex = 0;
            cbLanguage.SelectedIndex = 0;

            currentNFI = new CultureInfo( cbLanguage.SelectedItem.ToString(), false ).NumberFormat;
            currentDTFI = new CultureInfo( cbLanguage.SelectedItem.ToString(), false ).DateTimeFormat;

            pgNumberInfo.SelectedObject = currentNFI;
            pgDateTime.SelectedObject = currentDTFI;
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
            this.numericUpDown1 = new System.Windows.Forms.NumericUpDown();
            this.groupBox1 = new System.Windows.Forms.GroupBox();
            this.label4 = new System.Windows.Forms.Label();
            this.cbLanguage = new System.Windows.Forms.ComboBox();
            this.lblCurrency = new System.Windows.Forms.Label();
            this.label3 = new System.Windows.Forms.Label();
            this.lblUpDown = new System.Windows.Forms.Label();
            this.label1 = new System.Windows.Forms.Label();
            this.groupBox3 = new System.Windows.Forms.GroupBox();
            this.label5 = new System.Windows.Forms.Label();
            this.pgDateTime = new System.Windows.Forms.PropertyGrid();
            this.label2 = new System.Windows.Forms.Label();
            this.pgNumberInfo = new System.Windows.Forms.PropertyGrid();
            this.groupBox2 = new System.Windows.Forms.GroupBox();
            this.lblDateTime = new System.Windows.Forms.Label();
            this.label6 = new System.Windows.Forms.Label();
            this.cbDateTimeFormat = new System.Windows.Forms.ComboBox();
            ((System.ComponentModel.ISupportInitialize)(this.numericUpDown1)).BeginInit();
            this.groupBox1.SuspendLayout();
            this.groupBox3.SuspendLayout();
            this.groupBox2.SuspendLayout();
            this.SuspendLayout();
            // 
            // numericUpDown1
            // 
            this.numericUpDown1.DecimalPlaces = 2;
            this.numericUpDown1.Increment = new System.Decimal(new int[] {
                                                                             55,
                                                                             0,
                                                                             0,
                                                                             65536});
            this.numericUpDown1.Location = new System.Drawing.Point(8, 72);
            this.numericUpDown1.Maximum = new System.Decimal(new int[] {
                                                                           10000,
                                                                           0,
                                                                           0,
                                                                           0});
            this.numericUpDown1.Minimum = new System.Decimal(new int[] {
                                                                           10000,
                                                                           0,
                                                                           0,
                                                                           -2147483648});
            this.numericUpDown1.Name = "numericUpDown1";
            this.numericUpDown1.Size = new System.Drawing.Size(256, 20);
            this.numericUpDown1.TabIndex = 0;
            this.numericUpDown1.ThousandsSeparator = true;
            this.numericUpDown1.Value = new System.Decimal(new int[] {
                                                                         110,
                                                                         0,
                                                                         0,
                                                                         65536});
            this.numericUpDown1.ValueChanged += new System.EventHandler(this.numericUpDown1_ValueChanged);
            // 
            // groupBox1
            // 
            this.groupBox1.Controls.Add(this.label4);
            this.groupBox1.Controls.Add(this.cbLanguage);
            this.groupBox1.Controls.Add(this.lblCurrency);
            this.groupBox1.Controls.Add(this.label3);
            this.groupBox1.Controls.Add(this.lblUpDown);
            this.groupBox1.Controls.Add(this.label1);
            this.groupBox1.Controls.Add(this.numericUpDown1);
            this.groupBox1.Location = new System.Drawing.Point(8, 8);
            this.groupBox1.Name = "groupBox1";
            this.groupBox1.Size = new System.Drawing.Size(272, 184);
            this.groupBox1.TabIndex = 1;
            this.groupBox1.TabStop = false;
            this.groupBox1.Text = "Numeric Tests";
            // 
            // label4
            // 
            this.label4.Location = new System.Drawing.Point(8, 24);
            this.label4.Name = "label4";
            this.label4.Size = new System.Drawing.Size(100, 16);
            this.label4.TabIndex = 6;
            this.label4.Text = "Language";
            // 
            // cbLanguage
            // 
            this.cbLanguage.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
            this.cbLanguage.Location = new System.Drawing.Point(8, 40);
            this.cbLanguage.Name = "cbLanguage";
            this.cbLanguage.Size = new System.Drawing.Size(256, 21);
            this.cbLanguage.TabIndex = 5;
            this.cbLanguage.SelectedIndexChanged += new System.EventHandler(this.cbLanguage_SelectedIndexChanged);
            // 
            // lblCurrency
            // 
            this.lblCurrency.BackColor = System.Drawing.Color.Silver;
            this.lblCurrency.Location = new System.Drawing.Point(8, 160);
            this.lblCurrency.Name = "lblCurrency";
            this.lblCurrency.Size = new System.Drawing.Size(248, 16);
            this.lblCurrency.TabIndex = 4;
            // 
            // label3
            // 
            this.label3.Location = new System.Drawing.Point(8, 144);
            this.label3.Name = "label3";
            this.label3.Size = new System.Drawing.Size(208, 16);
            this.label3.TabIndex = 3;
            this.label3.Text = "UpDown Conversion to currency";
            // 
            // lblUpDown
            // 
            this.lblUpDown.BackColor = System.Drawing.Color.Silver;
            this.lblUpDown.Location = new System.Drawing.Point(8, 120);
            this.lblUpDown.Name = "lblUpDown";
            this.lblUpDown.Size = new System.Drawing.Size(248, 16);
            this.lblUpDown.TabIndex = 2;
            // 
            // label1
            // 
            this.label1.Location = new System.Drawing.Point(8, 104);
            this.label1.Name = "label1";
            this.label1.Size = new System.Drawing.Size(248, 16);
            this.label1.TabIndex = 1;
            this.label1.Text = "UpDown Converstion to String";
            // 
            // groupBox3
            // 
            this.groupBox3.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
                | System.Windows.Forms.AnchorStyles.Left) 
                | System.Windows.Forms.AnchorStyles.Right)));
            this.groupBox3.Controls.Add(this.label5);
            this.groupBox3.Controls.Add(this.pgDateTime);
            this.groupBox3.Controls.Add(this.label2);
            this.groupBox3.Controls.Add(this.pgNumberInfo);
            this.groupBox3.Location = new System.Drawing.Point(288, 8);
            this.groupBox3.Name = "groupBox3";
            this.groupBox3.Size = new System.Drawing.Size(360, 360);
            this.groupBox3.TabIndex = 3;
            this.groupBox3.TabStop = false;
            this.groupBox3.Text = "Format Info";
            // 
            // label5
            // 
            this.label5.Location = new System.Drawing.Point(8, 192);
            this.label5.Name = "label5";
            this.label5.Size = new System.Drawing.Size(100, 16);
            this.label5.TabIndex = 3;
            this.label5.Text = "DateTimeFormat";
            // 
            // pgDateTime
            // 
            this.pgDateTime.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
                | System.Windows.Forms.AnchorStyles.Left) 
                | System.Windows.Forms.AnchorStyles.Right)));
            this.pgDateTime.CommandsVisibleIfAvailable = true;
            this.pgDateTime.HelpVisible = false;
            this.pgDateTime.LargeButtons = false;
            this.pgDateTime.LineColor = System.Drawing.SystemColors.ScrollBar;
            this.pgDateTime.Location = new System.Drawing.Point(8, 208);
            this.pgDateTime.Name = "pgDateTime";
            this.pgDateTime.Size = new System.Drawing.Size(344, 144);
            this.pgDateTime.TabIndex = 2;
            this.pgDateTime.Text = "propertyGrid1";
            this.pgDateTime.ToolbarVisible = false;
            this.pgDateTime.ViewBackColor = System.Drawing.SystemColors.Window;
            this.pgDateTime.ViewForeColor = System.Drawing.Color.FromArgb(((System.Byte)(64)), ((System.Byte)(64)), ((System.Byte)(64)));
            // 
            // label2
            // 
            this.label2.Location = new System.Drawing.Point(8, 24);
            this.label2.Name = "label2";
            this.label2.Size = new System.Drawing.Size(100, 16);
            this.label2.TabIndex = 1;
            this.label2.Text = "NumberInfo";
            // 
            // pgNumberInfo
            // 
            this.pgNumberInfo.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
                | System.Windows.Forms.AnchorStyles.Right)));
            this.pgNumberInfo.CommandsVisibleIfAvailable = true;
            this.pgNumberInfo.HelpVisible = false;
            this.pgNumberInfo.LargeButtons = false;
            this.pgNumberInfo.LineColor = System.Drawing.SystemColors.ScrollBar;
            this.pgNumberInfo.Location = new System.Drawing.Point(8, 40);
            this.pgNumberInfo.Name = "pgNumberInfo";
            this.pgNumberInfo.Size = new System.Drawing.Size(344, 144);
            this.pgNumberInfo.TabIndex = 0;
            this.pgNumberInfo.Text = "propertyGrid1";
            this.pgNumberInfo.ToolbarVisible = false;
            this.pgNumberInfo.ViewBackColor = System.Drawing.SystemColors.Window;
            this.pgNumberInfo.ViewForeColor = System.Drawing.Color.FromArgb(((System.Byte)(64)), ((System.Byte)(64)), ((System.Byte)(64)));
            // 
            // groupBox2
            // 
            this.groupBox2.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
                | System.Windows.Forms.AnchorStyles.Left)));
            this.groupBox2.Controls.Add(this.lblDateTime);
            this.groupBox2.Controls.Add(this.label6);
            this.groupBox2.Controls.Add(this.cbDateTimeFormat);
            this.groupBox2.Location = new System.Drawing.Point(8, 200);
            this.groupBox2.Name = "groupBox2";
            this.groupBox2.Size = new System.Drawing.Size(272, 168);
            this.groupBox2.TabIndex = 4;
            this.groupBox2.TabStop = false;
            this.groupBox2.Text = "Date Time Tests";
            // 
            // lblDateTime
            // 
            this.lblDateTime.BackColor = System.Drawing.Color.Silver;
            this.lblDateTime.Location = new System.Drawing.Point(8, 96);
            this.lblDateTime.Name = "lblDateTime";
            this.lblDateTime.Size = new System.Drawing.Size(256, 23);
            this.lblDateTime.TabIndex = 2;
            // 
            // label6
            // 
            this.label6.Location = new System.Drawing.Point(8, 48);
            this.label6.Name = "label6";
            this.label6.Size = new System.Drawing.Size(100, 16);
            this.label6.TabIndex = 1;
            this.label6.Text = "Format";
            // 
            // cbDateTimeFormat
            // 
            this.cbDateTimeFormat.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
            this.cbDateTimeFormat.Location = new System.Drawing.Point(8, 64);
            this.cbDateTimeFormat.Name = "cbDateTimeFormat";
            this.cbDateTimeFormat.Size = new System.Drawing.Size(256, 21);
            this.cbDateTimeFormat.TabIndex = 0;
            this.cbDateTimeFormat.SelectedIndexChanged += new System.EventHandler(this.cbDateTimeFormat_SelectedIndexChanged);
            // 
            // Form1
            // 
            this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
            this.ClientSize = new System.Drawing.Size(664, 374);
            this.Controls.Add(this.groupBox2);
            this.Controls.Add(this.groupBox3);
            this.Controls.Add(this.groupBox1);
            this.Name = "Form1";
            this.Text = "Culture Format Test";
            ((System.ComponentModel.ISupportInitialize)(this.numericUpDown1)).EndInit();
            this.groupBox1.ResumeLayout(false);
            this.groupBox3.ResumeLayout(false);
            this.groupBox2.ResumeLayout(false);
            this.ResumeLayout(false);

        }
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new Form1());
		}

        private void numericUpDown1_ValueChanged(object sender, System.EventArgs e)
        {
            // demonstrates formatting a value using correct culture number format
            currentNFI = new CultureInfo( cbLanguage.SelectedItem.ToString(), false ).NumberFormat;

            lblUpDown.Text = numericUpDown1.Value.ToString("N", currentNFI);
            lblCurrency.Text = numericUpDown1.Value.ToString( "C", currentNFI );
        }

        private void cbLanguage_SelectedIndexChanged(object sender, System.EventArgs e)
        {
            currentDTFI = new CultureInfo( cbLanguage.SelectedItem.ToString(), false ).DateTimeFormat;
            currentNFI = new CultureInfo( cbLanguage.SelectedItem.ToString(), false ).NumberFormat;

            pgNumberInfo.SelectedObject = currentNFI;
            pgDateTime.SelectedObject = currentDTFI;

            cbDateTimeFormat_SelectedIndexChanged(null, null);
            numericUpDown1_ValueChanged(null, null);
        }

        private void cbDateTimeFormat_SelectedIndexChanged(object sender, System.EventArgs e)
        {
           lblDateTime.Text = DateTime.Today.ToString( cbDateTimeFormat.SelectedItem.ToString(), currentDTFI );
        }
	}
}
