using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;

namespace _13_ListView
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class Form1 : System.Windows.Forms.Form
	{
        private System.Windows.Forms.GroupBox groupBox1;
        private System.Windows.Forms.GroupBox groupBox2;
        private System.Windows.Forms.ListView lvChosen;
        private System.Windows.Forms.Button btnSingleAdd;
        private System.Windows.Forms.Button btnAllAdd;
        private System.Windows.Forms.Button btnSingleRemove;
        private System.Windows.Forms.Button btnAllRemove;
        private System.Windows.Forms.ListView lvAvailable;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public Form1()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

            // adding with a string
            lvAvailable.Items.Add( "Normal" );

            // adding with a ListViewItem
            ListViewItem listViewItem1 = new ListViewItem( "Happy" );
            listViewItem1.ForeColor = Color.Red;
            lvAvailable.Items.Add( listViewItem1 );

            // adding an array of ListViewItems
            ListViewItem[] lvItems = new ListViewItem[]{ new ListViewItem("Sad"),
                                                         new ListViewItem("Angry"),
                                                         new ListViewItem("Surprised"),
                                                         new ListViewItem("Bashful")};
        
            lvAvailable.Items.AddRange( lvItems );
        }

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
            this.lvChosen = new System.Windows.Forms.ListView();
            this.groupBox1 = new System.Windows.Forms.GroupBox();
            this.lvAvailable = new System.Windows.Forms.ListView();
            this.groupBox2 = new System.Windows.Forms.GroupBox();
            this.btnSingleAdd = new System.Windows.Forms.Button();
            this.btnAllAdd = new System.Windows.Forms.Button();
            this.btnSingleRemove = new System.Windows.Forms.Button();
            this.btnAllRemove = new System.Windows.Forms.Button();
            this.groupBox1.SuspendLayout();
            this.groupBox2.SuspendLayout();
            this.SuspendLayout();
            // 
            // lvChosen
            // 
            this.lvChosen.Location = new System.Drawing.Point(8, 16);
            this.lvChosen.Name = "lvChosen";
            this.lvChosen.Size = new System.Drawing.Size(288, 232);
            this.lvChosen.TabIndex = 0;
            // 
            // groupBox1
            // 
            this.groupBox1.Controls.Add(this.lvAvailable);
            this.groupBox1.Location = new System.Drawing.Point(8, 8);
            this.groupBox1.Name = "groupBox1";
            this.groupBox1.Size = new System.Drawing.Size(304, 256);
            this.groupBox1.TabIndex = 1;
            this.groupBox1.TabStop = false;
            this.groupBox1.Text = "Available Emoticons";
            // 
            // lvAvailable
            // 
            this.lvAvailable.Location = new System.Drawing.Point(8, 16);
            this.lvAvailable.Name = "lvAvailable";
            this.lvAvailable.Size = new System.Drawing.Size(288, 232);
            this.lvAvailable.TabIndex = 0;
            // 
            // groupBox2
            // 
            this.groupBox2.Controls.Add(this.lvChosen);
            this.groupBox2.Location = new System.Drawing.Point(432, 8);
            this.groupBox2.Name = "groupBox2";
            this.groupBox2.Size = new System.Drawing.Size(304, 256);
            this.groupBox2.TabIndex = 0;
            this.groupBox2.TabStop = false;
            this.groupBox2.Text = "Chosen Emoticons";
            // 
            // btnSingleAdd
            // 
            this.btnSingleAdd.Location = new System.Drawing.Point(336, 40);
            this.btnSingleAdd.Name = "btnSingleAdd";
            this.btnSingleAdd.TabIndex = 2;
            this.btnSingleAdd.Text = ">";
            this.btnSingleAdd.Click += new System.EventHandler(this.btnSingleAdd_Click);
            // 
            // btnAllAdd
            // 
            this.btnAllAdd.Location = new System.Drawing.Point(336, 80);
            this.btnAllAdd.Name = "btnAllAdd";
            this.btnAllAdd.TabIndex = 3;
            this.btnAllAdd.Text = ">>";
            this.btnAllAdd.Click += new System.EventHandler(this.btnAllAdd_Click);
            // 
            // btnSingleRemove
            // 
            this.btnSingleRemove.Location = new System.Drawing.Point(336, 168);
            this.btnSingleRemove.Name = "btnSingleRemove";
            this.btnSingleRemove.TabIndex = 4;
            this.btnSingleRemove.Text = "<";
            this.btnSingleRemove.Click += new System.EventHandler(this.btnSingleRemove_Click);
            // 
            // btnAllRemove
            // 
            this.btnAllRemove.Location = new System.Drawing.Point(336, 208);
            this.btnAllRemove.Name = "btnAllRemove";
            this.btnAllRemove.TabIndex = 5;
            this.btnAllRemove.Text = "<<";
            this.btnAllRemove.Click += new System.EventHandler(this.btnAllRemove_Click);
            // 
            // Form1
            // 
            this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
            this.ClientSize = new System.Drawing.Size(744, 286);
            this.Controls.Add(this.btnAllRemove);
            this.Controls.Add(this.btnSingleRemove);
            this.Controls.Add(this.btnAllAdd);
            this.Controls.Add(this.btnSingleAdd);
            this.Controls.Add(this.groupBox1);
            this.Controls.Add(this.groupBox2);
            this.Name = "Form1";
            this.Text = "Form1";
            this.groupBox1.ResumeLayout(false);
            this.groupBox2.ResumeLayout(false);
            this.ResumeLayout(false);

        }
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new Form1());
		}

        private void btnSingleAdd_Click(object sender, System.EventArgs e)
        {
            foreach( ListViewItem selectedEmoticon in lvAvailable.SelectedItems )
            {
                lvChosen.Items.Add( (ListViewItem) selectedEmoticon.Clone() );
            }
            foreach( ListViewItem lvItem in lvAvailable.SelectedItems )
                lvAvailable.Items.Remove( lvItem );
        }

        private void btnAllAdd_Click(object sender, System.EventArgs e)
        {
            foreach( ListViewItem lvItem in lvAvailable.Items )
                lvChosen.Items.Add( (ListViewItem) lvItem.Clone() );

            lvAvailable.Items.Clear();
        }

        private void btnSingleRemove_Click(object sender, System.EventArgs e)
        {
            foreach( ListViewItem selectedEmoticon in lvChosen.SelectedItems )
            {
                lvAvailable.Items.Add( (ListViewItem) selectedEmoticon.Clone() );
            }
            foreach( ListViewItem lvItem in lvChosen.SelectedItems )
                lvChosen.Items.Remove( lvItem );
        
        }

        private void btnAllRemove_Click(object sender, System.EventArgs e)
        {
            foreach( ListViewItem lvItem in lvChosen.Items )
                lvAvailable.Items.Add( (ListViewItem) lvItem.Clone() );

            lvChosen.Items.Clear();        
        }
	}
}
