using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using System.Text.RegularExpressions;

namespace _27_Validation
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class Form1 : System.Windows.Forms.Form
	{
        private System.Windows.Forms.TextBox tbPhone;
        private System.Windows.Forms.Label label1;
        private System.Windows.Forms.ErrorProvider errorProvider1;
        private System.Windows.Forms.Label label2;
        private System.Windows.Forms.TextBox tbFirstName;
        private System.Windows.Forms.Label label3;
        private System.Windows.Forms.TextBox tbLastName;
        private System.Windows.Forms.Button btnValidate;

		private System.ComponentModel.Container components = null;

		public Form1()
		{
			InitializeComponent();
		}

		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		private void InitializeComponent()
		{
            this.tbPhone = new System.Windows.Forms.TextBox();
            this.label1 = new System.Windows.Forms.Label();
            this.btnValidate = new System.Windows.Forms.Button();
            this.errorProvider1 = new System.Windows.Forms.ErrorProvider();
            this.label2 = new System.Windows.Forms.Label();
            this.tbFirstName = new System.Windows.Forms.TextBox();
            this.label3 = new System.Windows.Forms.Label();
            this.tbLastName = new System.Windows.Forms.TextBox();
            this.SuspendLayout();
            // 
            // tbPhone
            // 
            this.tbPhone.Location = new System.Drawing.Point(8, 120);
            this.tbPhone.Name = "tbPhone";
            this.tbPhone.Size = new System.Drawing.Size(176, 20);
            this.tbPhone.TabIndex = 0;
            this.tbPhone.Text = "";
            this.tbPhone.Validated += new System.EventHandler(this.tbPhone_Validated);
            // 
            // label1
            // 
            this.label1.Location = new System.Drawing.Point(8, 104);
            this.label1.Name = "label1";
            this.label1.Size = new System.Drawing.Size(100, 16);
            this.label1.TabIndex = 1;
            this.label1.Text = "Phone Number";
            // 
            // btnValidate
            // 
            this.btnValidate.Location = new System.Drawing.Point(48, 168);
            this.btnValidate.Name = "btnValidate";
            this.btnValidate.Size = new System.Drawing.Size(96, 23);
            this.btnValidate.TabIndex = 2;
            this.btnValidate.Text = "Validate";
            this.btnValidate.Click += new System.EventHandler(this.btnValidate_Click);
            // 
            // errorProvider1
            // 
            this.errorProvider1.ContainerControl = this;
            // 
            // label2
            // 
            this.label2.Location = new System.Drawing.Point(8, 8);
            this.label2.Name = "label2";
            this.label2.Size = new System.Drawing.Size(100, 16);
            this.label2.TabIndex = 3;
            this.label2.Text = "First Name";
            // 
            // tbFirstName
            // 
            this.tbFirstName.Location = new System.Drawing.Point(8, 24);
            this.tbFirstName.Name = "tbFirstName";
            this.tbFirstName.Size = new System.Drawing.Size(176, 20);
            this.tbFirstName.TabIndex = 4;
            this.tbFirstName.Text = "";
            this.tbFirstName.Validating += new System.ComponentModel.CancelEventHandler(this.tbFirstName_Validating);
            this.tbFirstName.Validated += new System.EventHandler(this.tbFirstName_Validated);
            // 
            // label3
            // 
            this.label3.Location = new System.Drawing.Point(8, 56);
            this.label3.Name = "label3";
            this.label3.Size = new System.Drawing.Size(100, 16);
            this.label3.TabIndex = 5;
            this.label3.Text = "Last Name";
            // 
            // tbLastName
            // 
            this.tbLastName.Location = new System.Drawing.Point(8, 72);
            this.tbLastName.Name = "tbLastName";
            this.tbLastName.Size = new System.Drawing.Size(176, 20);
            this.tbLastName.TabIndex = 6;
            this.tbLastName.Text = "";
            this.tbLastName.Validating += new System.ComponentModel.CancelEventHandler(this.tbLastName_Validating);
            this.tbLastName.Validated += new System.EventHandler(this.tbLastName_Validated);
            // 
            // Form1
            // 
            this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
            this.ClientSize = new System.Drawing.Size(208, 214);
            this.Controls.Add(this.tbLastName);
            this.Controls.Add(this.label3);
            this.Controls.Add(this.tbFirstName);
            this.Controls.Add(this.label2);
            this.Controls.Add(this.btnValidate);
            this.Controls.Add(this.label1);
            this.Controls.Add(this.tbPhone);
            this.Name = "Form1";
            this.Text = "Registration";
            this.ResumeLayout(false);

        }
		#endregion

        [STAThread]
		static void Main() 
		{
			Application.Run(new Form1());
		}

        private void tbPhone_Validated(object sender, System.EventArgs e)
        {
            Regex phoneExp = new Regex( @"^\(\d{3}\)\s\d{3}-\d{4}$" );

            if( tbPhone.Text == "" )
            {
                errorProvider1.SetError( tbPhone, "Please enter a phone number" );
            }
            else if( phoneExp.Match( tbPhone.Text ).Success == false )
            {
                errorProvider1.SetError( tbPhone, "Invalid Phone Number" );
            }
            else
            {
                errorProvider1.SetError( tbPhone, "" );
            }
        }

        private void tbFirstName_Validated(object sender, System.EventArgs e)
        {
            // clear error if they filled in first name
            if( tbFirstName.Text != "" )
                errorProvider1.SetError( tbFirstName, "" );
        }

        private void tbLastName_Validated(object sender, System.EventArgs e)
        {  
            // clear error since control is validated
            errorProvider1.SetError( tbLastName, "" );
        }

        private void tbLastName_Validating(object sender, System.ComponentModel.CancelEventArgs e)
        {
            if( tbLastName.Text == "" )
            {
                // setting e.Cancel to true requires user to fill in field before continuing
                e.Cancel = true;
                errorProvider1.SetError( tbLastName, "Please enter a last name" );
            }
        }

        private void tbFirstName_Validating(object sender, System.ComponentModel.CancelEventArgs e)
        {
            if( tbFirstName.Text == "" )
            {
                // set error field but allow user to set focus to other controls
                errorProvider1.SetError( tbFirstName, "Please enter a first name" );
            }
        }

        private void btnValidate_Click(object sender, System.EventArgs e)
        {
            Validate();
        }
	}
}
