using System;
using System.Collections;
using System.ComponentModel;
using System.Drawing;
using System.Data;
using System.Windows.Forms;
using System.IO;
using System.Diagnostics;

namespace _1_ComCtrlExtension
{
    public class ScreenSaverPreviewPanel : System.Windows.Forms.Panel
    {
        private System.ComponentModel.IContainer components;
        private string screenSaver = "";
        private Process saverProcess = null;

        private bool launched = false;

        public ScreenSaverPreviewPanel()
        {
            InitializeComponent();
        }

        protected override void OnPaint(PaintEventArgs e)
        {
            if( launched == false )
            {
                try
                {
                    if( saverProcess != null )
                    {
                        saverProcess.Kill();
                        saverProcess = null;
                    }

                    if( this.Visible == true && screenSaver != "")
                    {
                        ProcessStartInfo startInfo = new ProcessStartInfo( screenSaver + " \"/p " + this.Handle.ToString() + "\"", "" );
                        startInfo.UseShellExecute = false;
                        saverProcess = Process.Start( startInfo );
                        launched = true;
                    }
                    else
                    {
                        this.Visible = false;
                    }
                }
                catch( Exception ex )
                {
                    throw new Exception( "Could not launch screen saver", ex );
                }
            }
            base.OnPaint (e);
        }

        protected override void Dispose( bool disposing )
        {
            if( disposing )
            {
                if( components != null )
                    components.Dispose();
            }
            base.Dispose( disposing );
        }

        #region Component Designer generated code>
        private void InitializeComponent()
        {
            this.components = new System.ComponentModel.Container();

        }
        #endregion

        public string ScreenSaverPath
        {
            get
            {
                return screenSaver;
            }
            set
            {
                this.Visible = true;
                screenSaver = value;
                launched = false;
                Invalidate();
            }
        }
    }
}
