using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using System.Xml;

namespace _1_XmlTextReader
{
    public class Form1 : System.Windows.Forms.Form
    {
        private System.Windows.Forms.MainMenu mainMenu1;
        private System.Windows.Forms.MenuItem menuItem1;
        private System.Windows.Forms.MenuItem mnuOpen;
        private System.Windows.Forms.MenuItem menuItem3;
        private System.Windows.Forms.TreeView tvXML;
        private System.Windows.Forms.OpenFileDialog openFileDialog1;
        private System.Windows.Forms.ListView lvAttributes;
        private System.Windows.Forms.ColumnHeader columnHeader1;
        private System.Windows.Forms.ColumnHeader columnHeader2;
        private System.Windows.Forms.Label label1;
        private System.Windows.Forms.Label lblTextNode;

        private System.ComponentModel.Container components = null;

        public Form1()
        {
            InitializeComponent();
        }

        protected override void Dispose( bool disposing )
        {
            if( disposing )
            {
                if (components != null) 
                {
                    components.Dispose();
                }
            }
            base.Dispose( disposing );
        }

        #region Windows Form Designer generated code
        private void InitializeComponent()
        {
            this.tvXML = new System.Windows.Forms.TreeView();
            this.mainMenu1 = new System.Windows.Forms.MainMenu();
            this.menuItem1 = new System.Windows.Forms.MenuItem();
            this.mnuOpen = new System.Windows.Forms.MenuItem();
            this.menuItem3 = new System.Windows.Forms.MenuItem();
            this.openFileDialog1 = new System.Windows.Forms.OpenFileDialog();
            this.lvAttributes = new System.Windows.Forms.ListView();
            this.columnHeader1 = new System.Windows.Forms.ColumnHeader();
            this.columnHeader2 = new System.Windows.Forms.ColumnHeader();
            this.label1 = new System.Windows.Forms.Label();
            this.lblTextNode = new System.Windows.Forms.Label();
            this.SuspendLayout();
            // 
            // tvXML
            // 
            this.tvXML.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
                | System.Windows.Forms.AnchorStyles.Right)));
            this.tvXML.ImageIndex = -1;
            this.tvXML.Location = new System.Drawing.Point(8, 8);
            this.tvXML.Name = "tvXML";
            this.tvXML.PathSeparator = "/";
            this.tvXML.SelectedImageIndex = -1;
            this.tvXML.Size = new System.Drawing.Size(416, 288);
            this.tvXML.TabIndex = 0;
            this.tvXML.AfterSelect += new System.Windows.Forms.TreeViewEventHandler(this.tvXML_AfterSelect);
            // 
            // mainMenu1
            // 
            this.mainMenu1.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
                                                                                      this.menuItem1});
            // 
            // menuItem1
            // 
            this.menuItem1.Index = 0;
            this.menuItem1.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
                                                                                      this.mnuOpen,
                                                                                      this.menuItem3});
            this.menuItem1.Text = "File";
            // 
            // mnuOpen
            // 
            this.mnuOpen.Index = 0;
            this.mnuOpen.Text = "&Open";
            this.mnuOpen.Click += new System.EventHandler(this.mnuOpen_Click);
            // 
            // menuItem3
            // 
            this.menuItem3.Index = 1;
            this.menuItem3.Text = "E&xit";
            // 
            // lvAttributes
            // 
            this.lvAttributes.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
                | System.Windows.Forms.AnchorStyles.Left) 
                | System.Windows.Forms.AnchorStyles.Right)));
            this.lvAttributes.Columns.AddRange(new System.Windows.Forms.ColumnHeader[] {
                                                                                           this.columnHeader1,
                                                                                           this.columnHeader2});
            this.lvAttributes.Location = new System.Drawing.Point(8, 328);
            this.lvAttributes.Name = "lvAttributes";
            this.lvAttributes.Size = new System.Drawing.Size(416, 160);
            this.lvAttributes.TabIndex = 1;
            this.lvAttributes.View = System.Windows.Forms.View.Details;
            // 
            // columnHeader1
            // 
            this.columnHeader1.Text = "Name";
            this.columnHeader1.Width = 200;
            // 
            // columnHeader2
            // 
            this.columnHeader2.Text = "Value";
            this.columnHeader2.Width = 400;
            // 
            // label1
            // 
            this.label1.Location = new System.Drawing.Point(8, 304);
            this.label1.Name = "label1";
            this.label1.Size = new System.Drawing.Size(40, 16);
            this.label1.TabIndex = 2;
            this.label1.Text = "Value:";
            // 
            // lblTextNode
            // 
            this.lblTextNode.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
                | System.Windows.Forms.AnchorStyles.Right)));
            this.lblTextNode.BackColor = System.Drawing.Color.Silver;
            this.lblTextNode.Location = new System.Drawing.Point(48, 304);
            this.lblTextNode.Name = "lblTextNode";
            this.lblTextNode.Size = new System.Drawing.Size(376, 16);
            this.lblTextNode.TabIndex = 3;
            // 
            // Form1
            // 
            this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
            this.ClientSize = new System.Drawing.Size(432, 489);
            this.Controls.Add(this.lblTextNode);
            this.Controls.Add(this.label1);
            this.Controls.Add(this.lvAttributes);
            this.Controls.Add(this.tvXML);
            this.Menu = this.mainMenu1;
            this.Name = "Form1";
            this.Text = "XML Viewer";
            this.ResumeLayout(false);

        }
        #endregion

        [STAThread]
        static void Main() 
        {
            Application.Run(new Form1());
        }

        private void mnuOpen_Click(object sender, System.EventArgs e)
        {
            if( openFileDialog1.ShowDialog(this) == DialogResult.OK )
            {
                PopulateTreeView( openFileDialog1.FileName );
            }
        }

        private void PopulateTreeView( string fileName )
        {
            XmlTextReader rdr = new XmlTextReader( fileName );
            rdr.WhitespaceHandling = WhitespaceHandling.None;
           
            Stack nodeStack = new Stack();
            TreeNode curTreeNode = null;

            // clear tree view
            tvXML.Nodes.Clear();

            while( rdr.Read() )
            {
                switch (rdr.NodeType) 
                {
                    // new start element found
                    case XmlNodeType.Element:
                    {
                        // push last element onto stack
                        if( curTreeNode != null )
                            nodeStack.Push( curTreeNode );

                        // create new element
                        curTreeNode = new TreeNode( rdr.Name );
                        curTreeNode.Tag = new Hashtable();

                        // populate attribute hashtable for element
                        if( rdr.HasAttributes == true )
                        {
                            curTreeNode.ForeColor = Color.Red;
                            while( rdr.MoveToNextAttribute() )
                            {
                                ((Hashtable) curTreeNode.Tag).Add( rdr.Name, rdr.Value );
                            }                    
                        }

                        // add element to proper place in tree.  Parent node is on top of stack
                        if( nodeStack.Count > 0 )
                            ((TreeNode) nodeStack.Peek()).Nodes.Add( curTreeNode );
                        else
                            tvXML.Nodes.Add( curTreeNode );

                        if( curTreeNode.Text.EndsWith( "/>" ))
                        {                            MessageBox.Show( "Ding" );
                            // pop the last parent node off the stack
                            if( nodeStack.Count > 0 )
                                curTreeNode = (TreeNode) nodeStack.Pop();
                        }
                        
                        break;
                    }
                    case XmlNodeType.Text:
                    {
                        ((Hashtable) curTreeNode.Tag).Add( "Text", rdr.Value );
                        break;
                    }
                    case XmlNodeType.EndElement:
                    {
                        // pop the last parent node off the stack
                        if( nodeStack.Count > 0 )
                            curTreeNode = (TreeNode) nodeStack.Pop();
                        break;
                    }
                    default:
                    {
                        break;
                    }
                }
            }    
            rdr.Close();
        }

        private void tvXML_AfterSelect(object sender, System.Windows.Forms.TreeViewEventArgs e)
        {
            // clear attribute list view
            lvAttributes.Items.Clear();

            Hashtable atts = (Hashtable )tvXML.SelectedNode.Tag;
            IDictionaryEnumerator attsEnum = atts.GetEnumerator();

            // enumerate tree node attribute hashtable and add to listview
            while( attsEnum.MoveNext() )
            {
                if( attsEnum.Key.ToString() != "Text" )
                    lvAttributes.Items.Add(new ListViewItem( new string[]{attsEnum.Key.ToString(), attsEnum.Value.ToString()} ));
            }

            if( ((Hashtable) tvXML.SelectedNode.Tag).ContainsKey( "Text" ))
            {
                lblTextNode.Text = ( ((Hashtable) tvXML.SelectedNode.Tag)["Text"].ToString());
            }
            else
            {
                lblTextNode.Text = "";
            }
        }
    }
}
