using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using System.Xml;
using System.Text;
using System.Xml.Schema;

namespace _7_XmlWriter
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class Form1 : System.Windows.Forms.Form
	{
        private System.Windows.Forms.MainMenu mainMenu1;
        private System.Windows.Forms.MenuItem menuItem1;
        private System.Windows.Forms.MenuItem mnuOpen;
        private System.Windows.Forms.MenuItem menuItem3;
        private System.Windows.Forms.TreeView tvXML;
        private System.Windows.Forms.OpenFileDialog openFileDialog1;
        private System.Windows.Forms.ListView lvAttributes;
        private System.Windows.Forms.ColumnHeader columnHeader1;
        private System.Windows.Forms.ColumnHeader columnHeader2;

		private System.ComponentModel.Container components = null;
        private System.Windows.Forms.Label lblElementXPath;
        private System.Windows.Forms.Label lblAttXPath;
        private System.Windows.Forms.MenuItem mnuViewXML;
        private System.Windows.Forms.MenuItem menuItem2;
        private System.Windows.Forms.TextBox tbXPath;
        private System.Windows.Forms.Button btnFind;

        private string xPathFind = "";
        private int listPos = 0;
        private XmlNodeList xPathResultList;
        private System.Windows.Forms.MenuItem mnuValidate;
        private XmlDocument xmlDoc;
        private System.Windows.Forms.MenuItem menuItem5;
        private System.Windows.Forms.ContextMenu cmTree;
        private System.Windows.Forms.MenuItem mnuAddChild;
        private System.Windows.Forms.MenuItem mnuDeleteNode;
        private System.Windows.Forms.ContextMenu cmAttributes;
        private System.Windows.Forms.MenuItem menuItem7;
        private System.Windows.Forms.MenuItem mnuAddAttribute;
        private System.Windows.Forms.MenuItem mnuDeleteAttribute;
        private System.Windows.Forms.MenuItem mnuSave;
        private System.Windows.Forms.MenuItem menuItem6;
        private System.Windows.Forms.MenuItem mnuSaveAs;
        private System.Windows.Forms.SaveFileDialog saveFileDialog1;
        private string currentDoc = "";

		public Form1()
		{
			InitializeComponent();
		}

		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
            this.tvXML = new System.Windows.Forms.TreeView();
            this.cmTree = new System.Windows.Forms.ContextMenu();
            this.mnuAddChild = new System.Windows.Forms.MenuItem();
            this.mnuDeleteNode = new System.Windows.Forms.MenuItem();
            this.menuItem5 = new System.Windows.Forms.MenuItem();
            this.mnuViewXML = new System.Windows.Forms.MenuItem();
            this.mainMenu1 = new System.Windows.Forms.MainMenu();
            this.menuItem1 = new System.Windows.Forms.MenuItem();
            this.mnuOpen = new System.Windows.Forms.MenuItem();
            this.mnuSave = new System.Windows.Forms.MenuItem();
            this.mnuSaveAs = new System.Windows.Forms.MenuItem();
            this.menuItem6 = new System.Windows.Forms.MenuItem();
            this.menuItem3 = new System.Windows.Forms.MenuItem();
            this.menuItem2 = new System.Windows.Forms.MenuItem();
            this.mnuValidate = new System.Windows.Forms.MenuItem();
            this.openFileDialog1 = new System.Windows.Forms.OpenFileDialog();
            this.lvAttributes = new System.Windows.Forms.ListView();
            this.columnHeader1 = new System.Windows.Forms.ColumnHeader();
            this.columnHeader2 = new System.Windows.Forms.ColumnHeader();
            this.cmAttributes = new System.Windows.Forms.ContextMenu();
            this.mnuAddAttribute = new System.Windows.Forms.MenuItem();
            this.mnuDeleteAttribute = new System.Windows.Forms.MenuItem();
            this.menuItem7 = new System.Windows.Forms.MenuItem();
            this.lblElementXPath = new System.Windows.Forms.Label();
            this.lblAttXPath = new System.Windows.Forms.Label();
            this.tbXPath = new System.Windows.Forms.TextBox();
            this.btnFind = new System.Windows.Forms.Button();
            this.saveFileDialog1 = new System.Windows.Forms.SaveFileDialog();
            this.SuspendLayout();
            // 
            // tvXML
            // 
            this.tvXML.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
                | System.Windows.Forms.AnchorStyles.Right)));
            this.tvXML.ContextMenu = this.cmTree;
            this.tvXML.HideSelection = false;
            this.tvXML.ImageIndex = -1;
            this.tvXML.LabelEdit = true;
            this.tvXML.Location = new System.Drawing.Point(8, 8);
            this.tvXML.Name = "tvXML";
            this.tvXML.PathSeparator = "/";
            this.tvXML.SelectedImageIndex = -1;
            this.tvXML.Size = new System.Drawing.Size(648, 440);
            this.tvXML.TabIndex = 0;
            this.tvXML.AfterSelect += new System.Windows.Forms.TreeViewEventHandler(this.tvXML_AfterSelect);
            this.tvXML.AfterLabelEdit += new System.Windows.Forms.NodeLabelEditEventHandler(this.tvXML_AfterLabelEdit);
            // 
            // cmTree
            // 
            this.cmTree.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
                                                                                   this.mnuAddChild,
                                                                                   this.mnuDeleteNode,
                                                                                   this.menuItem5,
                                                                                   this.mnuViewXML});
            // 
            // mnuAddChild
            // 
            this.mnuAddChild.Index = 0;
            this.mnuAddChild.Text = "Add Child Element";
            this.mnuAddChild.Click += new System.EventHandler(this.mnuAddChild_Click);
            // 
            // mnuDeleteNode
            // 
            this.mnuDeleteNode.Index = 1;
            this.mnuDeleteNode.Text = "Delete Node";
            this.mnuDeleteNode.Click += new System.EventHandler(this.mnuDeleteNode_Click);
            // 
            // menuItem5
            // 
            this.menuItem5.Index = 2;
            this.menuItem5.Text = "-";
            // 
            // mnuViewXML
            // 
            this.mnuViewXML.Index = 3;
            this.mnuViewXML.Text = "View XML";
            this.mnuViewXML.Click += new System.EventHandler(this.mnuViewXML_Click);
            // 
            // mainMenu1
            // 
            this.mainMenu1.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
                                                                                      this.menuItem1,
                                                                                      this.menuItem2});
            // 
            // menuItem1
            // 
            this.menuItem1.Index = 0;
            this.menuItem1.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
                                                                                      this.mnuOpen,
                                                                                      this.mnuSave,
                                                                                      this.mnuSaveAs,
                                                                                      this.menuItem6,
                                                                                      this.menuItem3});
            this.menuItem1.Text = "File";
            // 
            // mnuOpen
            // 
            this.mnuOpen.Index = 0;
            this.mnuOpen.Text = "&Open";
            this.mnuOpen.Click += new System.EventHandler(this.mnuOpen_Click);
            // 
            // mnuSave
            // 
            this.mnuSave.Index = 1;
            this.mnuSave.Text = "&Save";
            this.mnuSave.Click += new System.EventHandler(this.mnuSave_Click);
            // 
            // mnuSaveAs
            // 
            this.mnuSaveAs.Index = 2;
            this.mnuSaveAs.Text = "Save &As...";
            this.mnuSaveAs.Click += new System.EventHandler(this.mnuSaveAs_Click);
            // 
            // menuItem6
            // 
            this.menuItem6.Index = 3;
            this.menuItem6.Text = "-";
            // 
            // menuItem3
            // 
            this.menuItem3.Index = 4;
            this.menuItem3.Text = "E&xit";
            // 
            // menuItem2
            // 
            this.menuItem2.Index = 1;
            this.menuItem2.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
                                                                                      this.mnuValidate});
            this.menuItem2.Text = "Edit";
            // 
            // mnuValidate
            // 
            this.mnuValidate.Index = 0;
            this.mnuValidate.Text = "Validate...";
            this.mnuValidate.Click += new System.EventHandler(this.mnuValidate_Click);
            // 
            // lvAttributes
            // 
            this.lvAttributes.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
                | System.Windows.Forms.AnchorStyles.Left) 
                | System.Windows.Forms.AnchorStyles.Right)));
            this.lvAttributes.Columns.AddRange(new System.Windows.Forms.ColumnHeader[] {
                                                                                           this.columnHeader1,
                                                                                           this.columnHeader2});
            this.lvAttributes.ContextMenu = this.cmAttributes;
            this.lvAttributes.LabelEdit = true;
            this.lvAttributes.Location = new System.Drawing.Point(8, 480);
            this.lvAttributes.Name = "lvAttributes";
            this.lvAttributes.Size = new System.Drawing.Size(648, 168);
            this.lvAttributes.TabIndex = 1;
            this.lvAttributes.View = System.Windows.Forms.View.Details;
            this.lvAttributes.SelectedIndexChanged += new System.EventHandler(this.lvAttributes_SelectedIndexChanged);
            // 
            // columnHeader1
            // 
            this.columnHeader1.Text = "Name";
            this.columnHeader1.Width = 200;
            // 
            // columnHeader2
            // 
            this.columnHeader2.Text = "Value";
            this.columnHeader2.Width = 400;
            // 
            // cmAttributes
            // 
            this.cmAttributes.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
                                                                                         this.mnuAddAttribute,
                                                                                         this.mnuDeleteAttribute,
                                                                                         this.menuItem7});
            // 
            // mnuAddAttribute
            // 
            this.mnuAddAttribute.Index = 0;
            this.mnuAddAttribute.Text = "Add";
            this.mnuAddAttribute.Click += new System.EventHandler(this.mnuAddAttribute_Click);
            // 
            // mnuDeleteAttribute
            // 
            this.mnuDeleteAttribute.Index = 1;
            this.mnuDeleteAttribute.Text = "Delete";
            this.mnuDeleteAttribute.Click += new System.EventHandler(this.mnuDeleteAttribute_Click);
            // 
            // menuItem7
            // 
            this.menuItem7.Index = 2;
            this.menuItem7.Text = "-";
            // 
            // lblElementXPath
            // 
            this.lblElementXPath.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
                | System.Windows.Forms.AnchorStyles.Right)));
            this.lblElementXPath.BackColor = System.Drawing.Color.Silver;
            this.lblElementXPath.Location = new System.Drawing.Point(8, 448);
            this.lblElementXPath.Name = "lblElementXPath";
            this.lblElementXPath.Size = new System.Drawing.Size(352, 16);
            this.lblElementXPath.TabIndex = 2;
            // 
            // lblAttXPath
            // 
            this.lblAttXPath.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left) 
                | System.Windows.Forms.AnchorStyles.Right)));
            this.lblAttXPath.BackColor = System.Drawing.Color.Silver;
            this.lblAttXPath.Location = new System.Drawing.Point(8, 648);
            this.lblAttXPath.Name = "lblAttXPath";
            this.lblAttXPath.Size = new System.Drawing.Size(648, 16);
            this.lblAttXPath.TabIndex = 3;
            // 
            // tbXPath
            // 
            this.tbXPath.Location = new System.Drawing.Point(368, 448);
            this.tbXPath.Name = "tbXPath";
            this.tbXPath.Size = new System.Drawing.Size(200, 20);
            this.tbXPath.TabIndex = 4;
            this.tbXPath.Text = "";
            // 
            // btnFind
            // 
            this.btnFind.Location = new System.Drawing.Point(576, 448);
            this.btnFind.Name = "btnFind";
            this.btnFind.TabIndex = 5;
            this.btnFind.Text = "Find";
            this.btnFind.Click += new System.EventHandler(this.btnFind_Click);
            // 
            // saveFileDialog1
            // 
            this.saveFileDialog1.Filter = "XML Files|*.xml";
            // 
            // Form1
            // 
            this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
            this.ClientSize = new System.Drawing.Size(664, 673);
            this.Controls.Add(this.btnFind);
            this.Controls.Add(this.tbXPath);
            this.Controls.Add(this.lblAttXPath);
            this.Controls.Add(this.lblElementXPath);
            this.Controls.Add(this.lvAttributes);
            this.Controls.Add(this.tvXML);
            this.Menu = this.mainMenu1;
            this.Name = "Form1";
            this.Text = "Simple XML Editor";
            this.ResumeLayout(false);

        }
		#endregion

		[STAThread]
		static void Main() 
		{
			Application.Run(new Form1());
		}

        private void mnuOpen_Click(object sender, System.EventArgs e)
        {
            if( openFileDialog1.ShowDialog(this) == DialogResult.OK )
            {
                currentDoc = openFileDialog1.FileName;

                xmlDoc = new XmlDocument();

                PopulateTreeView( openFileDialog1.FileName );

                try
                {
                    xmlDoc.Load( openFileDialog1.FileName );
                }
                catch( Exception ex )
                {
                }
            }
        }

        private void PopulateTreeView( string fileName )
        {
            TreeNode curTreeNode = null;
            Stack nodeStack = new Stack();

            // load document
            XmlTextReader xmlTR = new XmlTextReader( fileName );
            XmlValidatingReader xmlVR = new XmlValidatingReader( xmlTR );
            xmlVR.ValidationEventHandler += new ValidationEventHandler (SchemaValidationHandler);

            // clear tree view
            tvXML.Nodes.Clear();

            try
            {
                while( xmlVR.Read() )
                {
                    switch (xmlVR.NodeType) 
                    {
                            // new start element found
                        case XmlNodeType.Element:
                        {
                            // push last element onto stack
                            if( curTreeNode != null )
                                nodeStack.Push( curTreeNode );

                            // create new element
                            curTreeNode = new TreeNode( xmlVR.Name );
                            curTreeNode.Tag = new Hashtable();

                            // populate attribute hashtable for element
                            if( xmlVR.HasAttributes == true )
                            {
                                curTreeNode.ForeColor = Color.Red;
                                while( xmlVR.MoveToNextAttribute() )
                                {
                                    ((Hashtable) curTreeNode.Tag).Add( xmlVR.Name, xmlVR.Value );
                                }                    
                            }

                            // add element to proper place in tree.  Parent node is on top of stack
                            if( nodeStack.Count > 0 )
                                ((TreeNode) nodeStack.Peek()).Nodes.Add( curTreeNode );
                            else
                                tvXML.Nodes.Add( curTreeNode );

                            break;
                        }
                        case XmlNodeType.EndElement:
                        {
                            // pop the last parent node off the stack
                            if( nodeStack.Count > 0 )
                                curTreeNode = (TreeNode) nodeStack.Pop();

                            break;
                        }
                        default:
                        {
                            break;
                        }
                    }
                }
            }    
            catch( Exception e )
            {
                
            }
            finally
            {
                if( xmlVR != null )
                    xmlVR.Close();
                if( xmlTR != null )
                    xmlTR.Close();
            }
        }

        public void SchemaValidationHandler(object sender, ValidationEventArgs args)
        {
            string error = "*** Validation Failed ***\n";
            error += args.Message;

            MessageBox.Show( this, error, "XML Viewer", MessageBoxButtons.OK, MessageBoxIcon.Error );
        }

        private void tvXML_AfterSelect(object sender, System.Windows.Forms.TreeViewEventArgs e)
        {
            // clear attribute list view
            lvAttributes.Items.Clear();
            
            XmlNode selNode = xmlDoc.SelectSingleNode(tvXML.SelectedNode.FullPath );
            if( selNode == null )
                return;

            foreach( XmlAttribute att in selNode.Attributes )
            {
                lvAttributes.Items.Add(new ListViewItem( new string[]{att.Name, att.Value} ));
            }

            lblElementXPath.Text = tvXML.SelectedNode.FullPath;
            lblAttXPath.Text = "";
        }

        private void lvAttributes_SelectedIndexChanged(object sender, System.EventArgs e)
        {
            if( lvAttributes.SelectedItems.Count == 0 )
            {
                lblAttXPath.Text = "";
                return;
            }

            lblAttXPath.Text = lblElementXPath.Text + "/@" + lvAttributes.SelectedItems[0].SubItems[0].Text;
        }

        private void mnuViewXML_Click(object sender, System.EventArgs e)
        {
            if( tvXML.SelectedNode == null )
                return;

            XmlNode nodes = xmlDoc.SelectSingleNode( tvXML.SelectedNode.FullPath );
            MessageBox.Show(nodes.OuterXml);

        }

        private void btnFind_Click(object sender, System.EventArgs e)
        {
            if( xPathFind != tbXPath.Text )
            {
                xPathFind = tbXPath.Text;

                xPathResultList = xmlDoc.SelectNodes( xPathFind );
                listPos = 0;
            }

            if( listPos >= xPathResultList.Count )
                listPos = 0;

            XmlNode curFind = xPathResultList[listPos];
            StringBuilder treePath = new StringBuilder();

            while( curFind != null && curFind.NodeType != XmlNodeType.Document )
            {
                treePath.Insert( 0, "/" + curFind.Name );
                curFind = curFind.ParentNode;
            }

            listPos++;
      
            SelectTreeNode( tvXML, treePath.ToString() );
        }

        private void SelectTreeNode( TreeView tv, string path )
        {
            string[] nodes = path.Split( new char[]{tv.PathSeparator[0]} );
            TreeNodeCollection curNodes = tv.Nodes;

            foreach( string curNode in nodes )
            {
                foreach( TreeNode child in curNodes )
                {
                    if( child.Text == curNode )
                    {
                        child.EnsureVisible();
                        tv.SelectedNode = child;
                        curNodes = child.Nodes;
                        break;
                    }
                }
            }
        }

        private void mnuValidate_Click(object sender, System.EventArgs e)
        {
            ValidateOpen vo = new ValidateOpen();
            if( vo.ShowDialog(this) == DialogResult.OK )
            {
                // load document
                XmlTextReader xmlTR = new XmlTextReader( currentDoc );
                XmlValidatingReader xmlVR = new XmlValidatingReader( xmlTR );
                xmlVR.ValidationEventHandler += new ValidationEventHandler (SchemaValidationHandler);

                // add schema
                xmlVR.Schemas.Add( null, vo.Path );
                while( xmlVR.Read() ){}

                xmlVR.Close();
            }
        }

        private void mnuAddChild_Click(object sender, System.EventArgs e)
        {
            // create new child element in xml document
            XmlElement newElem = xmlDoc.CreateElement( "newchild" );
            XmlNode selNode = xmlDoc.SelectSingleNode( tvXML.SelectedNode.FullPath );
            selNode.AppendChild( newElem );

            // add to tree view
            tvXML.SelectedNode.Nodes.Add( "newchild" );
        }

        private void mnuDeleteNode_Click(object sender, System.EventArgs e)
        {
            // get selected node
            XmlNode selNode = xmlDoc.SelectSingleNode( tvXML.SelectedNode.FullPath );
        
            // remove from xml doc
            selNode.ParentNode.RemoveChild( selNode );

            // remove from tree
            tvXML.SelectedNode.Remove();
        }

        private void mnuAddAttribute_Click(object sender, System.EventArgs e)
        {
            // query user for new attribute name and value
            AttributeEditor ae = new AttributeEditor();
            if( ae.ShowDialog() == DialogResult.Cancel )
                return;

            // get selected node
            XmlNode selNode = xmlDoc.SelectSingleNode( tvXML.SelectedNode.FullPath );
            
            // add attribute
            XmlAttribute newAtt = xmlDoc.CreateAttribute( ae.AttributeName );
            newAtt.Value = ae.AttributeValue;
            selNode.Attributes.SetNamedItem( newAtt );

            // add to listview
            lvAttributes.Items.Add( new ListViewItem( new string[]{ ae.AttributeName, ae.AttributeValue } ));

            // color treeview item
            tvXML.SelectedNode.ForeColor = Color.Red;
        }

        private void mnuDeleteAttribute_Click(object sender, System.EventArgs e)
        {
            // get selected node
            XmlNode selNode = xmlDoc.SelectSingleNode( tvXML.SelectedNode.FullPath );
        
            // remove attribute from xmldoc
            selNode.Attributes.RemoveNamedItem( lvAttributes.SelectedItems[0].Text );

            // remove from listview
            lvAttributes.SelectedItems[0].Remove();

            // color tree black if no more attributes
            if( selNode.Attributes.Count == 0 )
                tvXML.SelectedNode.ForeColor = Color.Black;
        }

        private void mnuSave_Click(object sender, System.EventArgs e)
        {
            Save( currentDoc );
        }

        private void mnuSaveAs_Click(object sender, System.EventArgs e)
        {
            if( saveFileDialog1.ShowDialog(this) == DialogResult.OK )
                Save( saveFileDialog1.FileName );
        }

        private void tvXML_AfterLabelEdit(object sender, System.Windows.Forms.NodeLabelEditEventArgs e)
        {
            string newName = XmlConvert.EncodeName( e.Label );

            // get selected node
            XmlNode selNode = xmlDoc.SelectSingleNode( tvXML.SelectedNode.FullPath );

            // rename tree view node to encoded name
            tvXML.SelectedNode.Text = newName;

            // stop the treeview from updating with new label
            e.CancelEdit = true;

            // create new element
            XmlElement newElem = xmlDoc.CreateElement( newName );

            // copy attributes from old to new
            foreach( XmlAttribute att in selNode.Attributes )
            {
                newElem.Attributes.SetNamedItem( att.CloneNode(true) );
            }

            // copy children nodes from old to new
            foreach( XmlNode childNode in selNode.ChildNodes )
                newElem.AppendChild( childNode.CloneNode(true) );

            // add to main doc
            selNode.ParentNode.ReplaceChild( newElem, selNode );
        }

        private void Save( string fileName )
        {
            XmlWriterProperties dlg = new XmlWriterProperties();
            dlg.FileName = fileName;
            dlg.Document = this.xmlDoc;

            dlg.ShowDialog();
        }
	}
}
