using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Xml;
using System.Text;
using System.IO;

namespace _8_Transform
{
	/// <summary>
	/// Summary description for XmlWriterProperties.
	/// </summary>
	public class XmlWriterProperties : System.Windows.Forms.Form
	{
        private System.Windows.Forms.PropertyGrid pgWriter;
        private string fileName = "";
        private XmlTextWriter writer;
        private XmlDocument document;
        private System.Windows.Forms.Button btnSave;

		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public XmlWriterProperties()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
            this.pgWriter = new System.Windows.Forms.PropertyGrid();
            this.btnSave = new System.Windows.Forms.Button();
            this.SuspendLayout();
            // 
            // pgWriter
            // 
            this.pgWriter.CommandsVisibleIfAvailable = true;
            this.pgWriter.LargeButtons = false;
            this.pgWriter.LineColor = System.Drawing.SystemColors.ScrollBar;
            this.pgWriter.Location = new System.Drawing.Point(8, 8);
            this.pgWriter.Name = "pgWriter";
            this.pgWriter.Size = new System.Drawing.Size(528, 336);
            this.pgWriter.TabIndex = 0;
            this.pgWriter.Text = "propertyGrid1";
            this.pgWriter.ViewBackColor = System.Drawing.SystemColors.Window;
            this.pgWriter.ViewForeColor = System.Drawing.SystemColors.WindowText;
            // 
            // btnSave
            // 
            this.btnSave.DialogResult = System.Windows.Forms.DialogResult.OK;
            this.btnSave.Location = new System.Drawing.Point(235, 360);
            this.btnSave.Name = "btnSave";
            this.btnSave.TabIndex = 1;
            this.btnSave.Text = "Save";
            this.btnSave.Click += new System.EventHandler(this.btnSave_Click);
            // 
            // XmlWriterProperties
            // 
            this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
            this.ClientSize = new System.Drawing.Size(544, 398);
            this.Controls.Add(this.btnSave);
            this.Controls.Add(this.pgWriter);
            this.Name = "XmlWriterProperties";
            this.Text = "XmlWriterProperties";
            this.ResumeLayout(false);

        }
		#endregion

        private void btnSave_Click(object sender, System.EventArgs e)
        {
            if( this.document == null )
                return;

            document.Save( writer );
            writer.Close();
        }

        public string FileName
        {
            set
            {
                this.fileName = value;
                writer = new XmlTextWriter( fileName, null );
                pgWriter.SelectedObject = writer;
            }
        }

        public XmlDocument Document
        {
            set
            {
                this.document = value;
            }
        }
	}
}
