using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using System.Net;
using System.IO;
using System.Text;
using System.Threading;

namespace _10_AsynchronousBrowser
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class Form1 : System.Windows.Forms.Form
	{
        private System.Windows.Forms.Label label1;
        private System.Windows.Forms.TextBox tbAddress;
        private System.Windows.Forms.Button btnGo;
        private System.Windows.Forms.RichTextBox tbContent;
        private System.Windows.Forms.Label label2;
        private System.Windows.Forms.TextBox tbProxyAddress;
        private System.Windows.Forms.Label label3;
        private System.Windows.Forms.TextBox tbProxyPort;

		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public Form1()
		{
			InitializeComponent();
            WebProxy proxy = WebProxy.GetDefaultProxy();
            if( proxy.Address != null )
            {
                tbProxyAddress.Text = proxy.Address.Host.ToString();
                tbProxyPort.Text = proxy.Address.Port.ToString();
            }
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
            this.label1 = new System.Windows.Forms.Label();
            this.tbAddress = new System.Windows.Forms.TextBox();
            this.btnGo = new System.Windows.Forms.Button();
            this.tbContent = new System.Windows.Forms.RichTextBox();
            this.label2 = new System.Windows.Forms.Label();
            this.tbProxyAddress = new System.Windows.Forms.TextBox();
            this.label3 = new System.Windows.Forms.Label();
            this.tbProxyPort = new System.Windows.Forms.TextBox();
            this.SuspendLayout();
            // 
            // label1
            // 
            this.label1.Location = new System.Drawing.Point(8, 8);
            this.label1.Name = "label1";
            this.label1.Size = new System.Drawing.Size(48, 16);
            this.label1.TabIndex = 0;
            this.label1.Text = "Address";
            // 
            // tbAddress
            // 
            this.tbAddress.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
                | System.Windows.Forms.AnchorStyles.Right)));
            this.tbAddress.Location = new System.Drawing.Point(56, 8);
            this.tbAddress.Name = "tbAddress";
            this.tbAddress.Size = new System.Drawing.Size(456, 20);
            this.tbAddress.TabIndex = 1;
            this.tbAddress.Text = "http://localhost";
            // 
            // btnGo
            // 
            this.btnGo.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right)));
            this.btnGo.Location = new System.Drawing.Point(520, 8);
            this.btnGo.Name = "btnGo";
            this.btnGo.TabIndex = 2;
            this.btnGo.Text = "Go";
            this.btnGo.Click += new System.EventHandler(this.btnGo_Click);
            // 
            // tbContent
            // 
            this.tbContent.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
                | System.Windows.Forms.AnchorStyles.Left) 
                | System.Windows.Forms.AnchorStyles.Right)));
            this.tbContent.Location = new System.Drawing.Point(8, 72);
            this.tbContent.Name = "tbContent";
            this.tbContent.Size = new System.Drawing.Size(584, 320);
            this.tbContent.TabIndex = 3;
            this.tbContent.Text = "richTextBox1";
            // 
            // label2
            // 
            this.label2.Location = new System.Drawing.Point(8, 40);
            this.label2.Name = "label2";
            this.label2.Size = new System.Drawing.Size(88, 16);
            this.label2.TabIndex = 4;
            this.label2.Text = "Proxy Address:";
            // 
            // tbProxyAddress
            // 
            this.tbProxyAddress.Location = new System.Drawing.Point(96, 38);
            this.tbProxyAddress.Name = "tbProxyAddress";
            this.tbProxyAddress.Size = new System.Drawing.Size(208, 20);
            this.tbProxyAddress.TabIndex = 5;
            this.tbProxyAddress.Text = "";
            // 
            // label3
            // 
            this.label3.Location = new System.Drawing.Point(312, 40);
            this.label3.Name = "label3";
            this.label3.Size = new System.Drawing.Size(32, 16);
            this.label3.TabIndex = 6;
            this.label3.Text = "Port:";
            // 
            // tbProxyPort
            // 
            this.tbProxyPort.Location = new System.Drawing.Point(344, 38);
            this.tbProxyPort.Name = "tbProxyPort";
            this.tbProxyPort.Size = new System.Drawing.Size(64, 20);
            this.tbProxyPort.TabIndex = 7;
            this.tbProxyPort.Text = "";
            // 
            // Form1
            // 
            this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
            this.ClientSize = new System.Drawing.Size(600, 409);
            this.Controls.Add(this.tbProxyPort);
            this.Controls.Add(this.tbProxyAddress);
            this.Controls.Add(this.tbAddress);
            this.Controls.Add(this.label3);
            this.Controls.Add(this.label2);
            this.Controls.Add(this.tbContent);
            this.Controls.Add(this.btnGo);
            this.Controls.Add(this.label1);
            this.Name = "Form1";
            this.Text = "Text Web Browser";
            this.ResumeLayout(false);

        }
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new Form1());
		}

        public class RequestState
        {
            public StringBuilder Content;
            public byte[] BufferRead;

            public HttpWebRequest Request = null;
            public Stream ResponseStream = null;
    
            public RequestState()
            {
                BufferRead = new byte[1024];
                Content = new StringBuilder("");
            }
        }

        private void ResponseCallback(IAsyncResult result)
        {
            // get state object attached to final result
            RequestState state = (RequestState) result.AsyncState;

            // Get the request and response objects
            HttpWebRequest request = state.Request;
            HttpWebResponse response = (HttpWebResponse) request.EndGetResponse(result);

            // place response stream into state
            state.ResponseStream = response.GetResponseStream();

            // Note that rs.BufferRead is passed in to BeginRead.  This is
            // where the data will be read into.
            IAsyncResult iarRead = state.ResponseStream.BeginRead(state.BufferRead, 0, 1024, new AsyncCallback(ReadCallBack), state);
        }

        private void ReadCallBack(IAsyncResult asyncResult)
        {
            // get state and response objects
            RequestState state = (RequestState)asyncResult.AsyncState;
        
            // end the reading and get bytes available
            int read = state.ResponseStream.EndRead( asyncResult );

            if (read > 0)
            {
                // get buffer data and append to state content result
                state.Content.Append( Encoding.ASCII.GetString(state.BufferRead, 0, read ));            

                // continue with data read
                IAsyncResult ar = state.ResponseStream.BeginRead( state.BufferRead, 0, 1024, new AsyncCallback(ReadCallBack), state);
            }
            else
            {
                if(state.Content.Length > 1)
                {
                    tbContent.Text = state.Content.ToString();
                }

                // Close down the response stream
                state.ResponseStream.Close();
            }
            return;
        }

        private void btnGo_Click(object sender, System.EventArgs e)
        {
            if( tbProxyAddress.Text != "" && tbProxyPort.Text != "" )
            {
                WebProxy proxyObject = new WebProxy(tbProxyAddress.Text, Int32.Parse( tbProxyPort.Text ));

                if( proxyObject != null )
                {
                    // don't use proxy for local addresses
                    proxyObject.BypassProxyOnLocal = true;

                    // make change global
                    GlobalProxySelection.Select = proxyObject;
                }
            }

            // create the request and state objects
            HttpWebRequest request = (HttpWebRequest) WebRequest.Create(tbAddress.Text);
            RequestState state = new RequestState();

            // save request object
            state.Request = request;

            // start the asynchronous call
            IAsyncResult res = (IAsyncResult) request.BeginGetResponse(new AsyncCallback(ResponseCallback), state);
        }
	}
}
