using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using System.Threading;
using System.Net;
using System.Net.Sockets;
using System.Text;

namespace _5_UDPFormClient
{
    public class Form1 : System.Windows.Forms.Form
    {
        private System.Windows.Forms.TextBox tbTranscript;
        private System.Windows.Forms.TextBox tbMessage;
        private System.Windows.Forms.Button btnSend;
        private Thread chatThread;
        private System.ComponentModel.Container components = null;
        private string name;

        UdpClient client;
        private System.Windows.Forms.TextBox tbName;
        private System.Windows.Forms.Label label1;
        private System.Windows.Forms.Button btnSetName;
        IPEndPoint serverIP;

        public Form1()
        {
            InitializeComponent();
           
            serverIP = new IPEndPoint( IPAddress.Parse( "127.0.0.1" ), 2003 );
            client = new UdpClient( new IPEndPoint( IPAddress.Any, 0 ));

            name = tbName.Text;

            // create a thread to start receiving broadcast messages
            chatThread = new Thread( new ThreadStart( ReceiveBroadcast )); 
            chatThread.Start();

            SendCommand( "300 " + name );
        }

        public void ReceiveBroadcast()
        {
            IPEndPoint receiveIP = new IPEndPoint(IPAddress.Any, 0);

            while( true )
            {
                byte[] data = client.Receive( ref receiveIP );
                tbTranscript.Text += Encoding.ASCII.GetString( data, 0, data.Length ) + "\r\n";
            }
        }

        protected override void Dispose( bool disposing )
        {
            if( disposing )
            {
                if (components != null) 
                {
                    components.Dispose();
                }
            }
            base.Dispose( disposing );
        }

        #region Windows Form Designer generated code
        /// <summary>
        /// Required method for Designer support - do not modify
        /// the contents of this method with the code editor.
        /// </summary>
        private void InitializeComponent()
        {
            this.tbTranscript = new System.Windows.Forms.TextBox();
            this.tbMessage = new System.Windows.Forms.TextBox();
            this.btnSend = new System.Windows.Forms.Button();
            this.tbName = new System.Windows.Forms.TextBox();
            this.label1 = new System.Windows.Forms.Label();
            this.btnSetName = new System.Windows.Forms.Button();
            this.SuspendLayout();
            // 
            // tbTranscript
            // 
            this.tbTranscript.Location = new System.Drawing.Point(8, 40);
            this.tbTranscript.Multiline = true;
            this.tbTranscript.Name = "tbTranscript";
            this.tbTranscript.Size = new System.Drawing.Size(536, 176);
            this.tbTranscript.TabIndex = 0;
            this.tbTranscript.Text = "";
            // 
            // tbMessage
            // 
            this.tbMessage.Location = new System.Drawing.Point(8, 224);
            this.tbMessage.Name = "tbMessage";
            this.tbMessage.Size = new System.Drawing.Size(456, 20);
            this.tbMessage.TabIndex = 1;
            this.tbMessage.Text = "";
            // 
            // btnSend
            // 
            this.btnSend.Location = new System.Drawing.Point(472, 224);
            this.btnSend.Name = "btnSend";
            this.btnSend.TabIndex = 2;
            this.btnSend.Text = "Send";
            this.btnSend.Click += new System.EventHandler(this.btnSend_Click);
            // 
            // tbName
            // 
            this.tbName.Location = new System.Drawing.Point(48, 9);
            this.tbName.Name = "tbName";
            this.tbName.Size = new System.Drawing.Size(200, 20);
            this.tbName.TabIndex = 3;
            this.tbName.Text = "Unknown";
            // 
            // label1
            // 
            this.label1.Location = new System.Drawing.Point(8, 11);
            this.label1.Name = "label1";
            this.label1.Size = new System.Drawing.Size(40, 16);
            this.label1.TabIndex = 4;
            this.label1.Text = "Name";
            // 
            // btnSetName
            // 
            this.btnSetName.Location = new System.Drawing.Point(256, 8);
            this.btnSetName.Name = "btnSetName";
            this.btnSetName.TabIndex = 5;
            this.btnSetName.Text = "Set";
            this.btnSetName.Click += new System.EventHandler(this.btnSetName_Click);
            // 
            // Form1
            // 
            this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
            this.ClientSize = new System.Drawing.Size(552, 254);
            this.Controls.Add(this.btnSetName);
            this.Controls.Add(this.label1);
            this.Controls.Add(this.tbName);
            this.Controls.Add(this.btnSend);
            this.Controls.Add(this.tbMessage);
            this.Controls.Add(this.tbTranscript);
            this.Name = "Form1";
            this.Text = "UDP Chat";
            this.Closed += new System.EventHandler(this.Form1_Closed);
            this.ResumeLayout(false);

        }
        #endregion

        [STAThread]
        static void Main() 
        {
            Application.Run(new Form1());
        }

        private void SendCommand( string command )
        {
            byte[] bytes = Encoding.ASCII.GetBytes(command);
            int ret = client.Send(bytes, bytes.Length, serverIP );
        }

        private void btnSend_Click(object sender, System.EventArgs e)
        {
            SendCommand( "400 " + tbMessage.Text );
        }

        private void btnSetName_Click(object sender, System.EventArgs e)
        {
            SendCommand( "301 " + name );
            SendCommand( "300 " + tbName.Text );
            name = tbName.Text;
        }

        private void Form1_Closed(object sender, System.EventArgs e)
        {
            SendCommand( "301 " + name );
        }
    }
}
