using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;

namespace _9_Asynchronous
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class Form1 : System.Windows.Forms.Form
	{
        private System.Windows.Forms.Button btnGo;
        private System.Windows.Forms.Label label1;
        private System.Timers.Timer timer1;
        private System.Windows.Forms.ProgressBar pbWait;
		private DateTime startTime;
        
        private System.ComponentModel.Container components = null;

		public Form1()
		{
			InitializeComponent();
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
            this.btnGo = new System.Windows.Forms.Button();
            this.label1 = new System.Windows.Forms.Label();
            this.timer1 = new System.Timers.Timer();
            this.pbWait = new System.Windows.Forms.ProgressBar();
            ((System.ComponentModel.ISupportInitialize)(this.timer1)).BeginInit();
            this.SuspendLayout();
            // 
            // btnGo
            // 
            this.btnGo.Location = new System.Drawing.Point(139, 88);
            this.btnGo.Name = "btnGo";
            this.btnGo.TabIndex = 0;
            this.btnGo.Text = "Go";
            this.btnGo.Click += new System.EventHandler(this.btnGo_Click);
            // 
            // label1
            // 
            this.label1.Location = new System.Drawing.Point(8, 16);
            this.label1.Name = "label1";
            this.label1.Size = new System.Drawing.Size(344, 64);
            this.label1.TabIndex = 1;
            this.label1.Text = "Pressing the Go button will call the GenerateNumbers method in the LotteryService" +
                " Web Service using a large value for Count.  The call will be done asynchronousl" +
                "y so the UI thread remains active.";
            // 
            // timer1
            // 
            this.timer1.Interval = 1000;
            this.timer1.SynchronizingObject = this;
            this.timer1.Elapsed += new System.Timers.ElapsedEventHandler(this.timer1_Elapsed);
            // 
            // pbWait
            // 
            this.pbWait.Location = new System.Drawing.Point(8, 120);
            this.pbWait.Maximum = 60;
            this.pbWait.Name = "pbWait";
            this.pbWait.Size = new System.Drawing.Size(336, 23);
            this.pbWait.Step = 1;
            this.pbWait.TabIndex = 2;
            // 
            // Form1
            // 
            this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
            this.ClientSize = new System.Drawing.Size(352, 150);
            this.Controls.Add(this.pbWait);
            this.Controls.Add(this.label1);
            this.Controls.Add(this.btnGo);
            this.Name = "Form1";
            this.Text = "Asynchronous Web Service Method Call";
            ((System.ComponentModel.ISupportInitialize)(this.timer1)).EndInit();
            this.ResumeLayout(false);

        }
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new Form1());
		}

        public void GenerateNumbersCallback(IAsyncResult ar)
        {
            DateTime endTime = DateTime.Now;

            // get result
            localhost.LotteryNumberGenerator gen = (localhost.LotteryNumberGenerator) ar.AsyncState;
            string result = gen.EndGenerateNumbers( ar );

            // stop timer and computer total time
            timer1.Enabled = false;

            TimeSpan span = new TimeSpan( endTime.Ticks - startTime.Ticks );
            MessageBox.Show( "Call time = " + span.ToString() + "\nResult: " + result );
        }

        private void btnGo_Click(object sender, System.EventArgs e)
        {
            localhost.LotteryNumberGenerator gen = new localhost.LotteryNumberGenerator();
            gen.BeginGenerateNumbers( 20000, 0, 100000, true, new AsyncCallback(GenerateNumbersCallback), gen );
            
            startTime = DateTime.Now;
            pbWait.Value = 0;
            timer1.Enabled = true;
        }

        private void timer1_Elapsed(object sender, System.Timers.ElapsedEventArgs e)
        {
            pbWait.PerformStep();
            if( pbWait.Value >= pbWait.Maximum )
                pbWait.Value = 0;
        }
	}
}
