using System;
using System.IO;
using System.Reflection;

namespace _10_DynamicInvocation
{
    /// <summary>
    /// Summary description for Class1.
    /// </summary>
    class Class1
    {
        /// <summary>
        /// The main entry point for the application.
        /// </summary>
        [STAThread]
        static void Main(string[] args)
        {
            if( args.Length < 0 )
            {
                ShowUsage();
                return;
            }

            if( Directory.Exists( args[0] ) == false)
            {
                Console.WriteLine( "Cannot find specified directory." );
                return;
            }

            foreach ( string fileName in Directory.GetFiles( args[0], "*.dll" ) )
            {
                Assembly curAsm = Assembly.LoadFile( fileName );
                foreach( Type t in curAsm.GetTypes() )
                {
                    MethodInfo hoarseMethod = t.GetMethod( "MakeHoarse" );
                    if( hoarseMethod == null )
                        continue;

                    object curObj = curAsm.CreateInstance( t.Name );
                    hoarseMethod.Invoke( curObj, null );
                }
            }
        }

        static void ShowUsage()
        {
            Console.WriteLine( "Usage: animalfarm.exe <directory>" );
        }
    }
}
