using System;
using System.Reflection;
using System.IO;
using System.Collections;

namespace _8_CustomSearch
{
    /// <summary>
    /// Summary description for Class1.
    /// </summary>
    class Class1
    {
        [STAThread]
        static int Main(string[] args)
        {
            if( args.Length <= 1 )
                return ShowUsage();
            
            ArrayList filterStrings = new ArrayList();

            // copy search strings to an array
            for( int i = 1; i < args.Length; i++ )
                filterStrings.Add(args[i]);

            // load assembly referenced in first cmd line arg
            Assembly asm = Assembly.LoadFile( args[0] );
            if( asm == null )
            {
                return ShowUsage();
            }


            // create the member filter delegate
            MemberFilter filter = new MemberFilter( OnCustomSearch );

            foreach( Module module in asm.GetModules() )
            {
                // enumerate through all types and search each member
                foreach( Type t in module.GetTypes() )
                {
                    // first check to see if the type name matches
                    if( filterStrings.Contains( t.Name ) )
                        Console.WriteLine( "Found type {0}", t.Name );

                    MemberInfo[] foundMembers = t.FindMembers( MemberTypes.All, BindingFlags.Public | BindingFlags.NonPublic | BindingFlags.Static | BindingFlags.Instance | BindingFlags.DeclaredOnly,
                        filter, filterStrings );

                    foreach( MemberInfo member in foundMembers )
                    {
                        Console.WriteLine( "Found member {0} which is a {1} defined in {2}.", member.Name, member.MemberType, t.Name );
                    }
                }
            }
            return 0;
        }

        public static bool OnCustomSearch( MemberInfo member, object filter )
        {
            ArrayList al = (ArrayList) filter;
            if( al.Contains( member.Name ))
                return true;

            if( al.Contains( member.MemberType ))
                return true;

            return false;
        }
        static int ShowUsage()
        {
            Console.WriteLine( "asmgrep <assemblyname> <string 1 string 2 ... string n>\n" );
            return -1;
        }
    }
}
