// CommandCom.h : Declaration of the CCommandCom

#pragma once
#include "resource.h"       // main symbols
#include <stdio.h>
#include <stdlib.h>

// ICommandCom
[
    object,
    uuid("9591AA26-FF42-4A13-BAD4-7C6256F8D2BC"),
    dual,	helpstring("ICommandCom Interface"),
    pointer_default(unique)
]
__interface ITest : IDispatch
{
    [id(30), helpstring("method Test2")] HRESULT Test2();
};

[
    object,
    uuid("9591AA26-FF42-4A13-BAD4-7C6256F8D2EA"),
    dual,	helpstring("ICommandCom Interface"),
    pointer_default(unique)
]
__interface ICommandCom : ITest
{
    [propget, id(1), helpstring("property CurrentDirectory")] HRESULT CurrentDirectory([out, retval] BSTR* pVal);
    [propput, id(1), helpstring("property CurrentDirectory")] HRESULT CurrentDirectory([in] BSTR newVal);
    [id(2), helpstring("method RunCommand")] HRESULT RunCommand([in] BSTR Cmd, [in] BSTR Params, [out,retval] BSTR* Result);
    [id(3), helpstring("method Test")] HRESULT Test();
    [id(4), helpstring("method Run")] HRESULT Run([in] BSTR Cmd, [out,retval] BSTR* Output);
    [id(5), helpstring("method ProcessCommands")] HRESULT ProcessCommands([in, satype(BSTR)] SAFEARRAY * commands, [out,retval] BSTR* Output);
    [id(6), helpstring("method TestArray")] HRESULT TestArray([in, satype(int)] SAFEARRAY * commands );
};


// _ICommandComEvents
[
    dispinterface,
    uuid("D0A89522-ABAF-423B-B021-A12F58F8DBBE"),
    helpstring("_ICommandComEvents Interface")
]
__interface _ICommandComEvents
{
    [id(1), helpstring("method SomeEvent")] HRESULT SomeEvent(void);
};


// CCommandCom

[
    coclass,
    threading("apartment"),
    event_source("com"),
    vi_progid("CmdShell.CommandCom"),
    progid("CmdShell.CommandCom.1"),
    version(1.0),
    uuid("155BB8B6-B19E-4131-BB4E-F7BFECF3F775"),
    helpstring("CommandCom Class")
]
class ATL_NO_VTABLE CCommandCom : 
    public ICommandCom
{
public:
    CCommandCom()
    {
    }

    __event __interface _ICommandComEvents;

    DECLARE_PROTECT_FINAL_CONSTRUCT()

    HRESULT FinalConstruct()
    {
        // generate temp file name
        GetModuleFileName( _AtlBaseModule.m_hInst, mTempFileName, MAX_PATH );
        *(_tcsrchr( mTempFileName, '\\' )) = '\0';
        _tcscat( mTempFileName, _T("\\output.txt" ));

        return S_OK;
    }

    void FinalRelease() 
    {
        DeleteFile( mTempFileName );
    }

    STDMETHOD(Test2()) {return S_OK;}
public:
    STDMETHOD(get_CurrentDirectory)(BSTR* pVal);
    STDMETHOD(put_CurrentDirectory)(BSTR newVal);
    STDMETHOD(RunCommand)(BSTR Cmd, BSTR Params, BSTR* Result);
    STDMETHOD(Test)();
    STDMETHOD(Run)(BSTR Cmd, BSTR* Output);
    STDMETHOD(ProcessCommands)(SAFEARRAY * commands, BSTR* Output);
    STDMETHOD(TestArray)(SAFEARRAY * commands ){return S_OK;}

private:
//    void GetResult( BSTR* Result );
    TCHAR mTempFileName[MAX_PATH];    
};

