// Vehicle.h : Declaration of the CVehicle

#pragma once
#include "resource.h"       // main symbols


// IVehicle
[
	object,
	uuid("886F5DD4-D664-460C-B879-48ACE89A86C2"),
	dual,	helpstring("IVehicle Interface"),
	pointer_default(unique)
]
__interface IVehicle : IDispatch
{
    [propget, id(1), helpstring("property NumWheels")] HRESULT NumWheels([out, retval] int* pVal);
    [propput, id(1), helpstring("property NumWheels")] HRESULT NumWheels([in] int newVal);
    [id(2), helpstring("method SpeedUp")] HRESULT SpeedUp([in] int Amount, [out,retval] int* CurrentSpeed);
};



// CVehicle

[
	coclass,
	threading("apartment"),
	vi_progid("ComObject.Vehicle"),
	progid("ComObject.Vehicle.1"),
	version(1.0),
	uuid("8D49CE22-B455-43F3-B397-17112D3D1E88"),
	helpstring("Vehicle Class")
]
class ATL_NO_VTABLE CVehicle : 
	public IVehicle
{
public:
	CVehicle()
	{
	}


	DECLARE_PROTECT_FINAL_CONSTRUCT()

	HRESULT FinalConstruct()
	{
		return S_OK;
	}
	
	void FinalRelease() 
	{
	}

public:

    STDMETHOD(get_NumWheels)(int* pVal);
    STDMETHOD(put_NumWheels)(int newVal);
    STDMETHOD(SpeedUp)(int Amount, int* CurrentSpeed);
};

