using System;

namespace DotNetObject
{

    public interface IVehicle
    {
        int Wheels
        {
            get;
            set;
        }
    }

    public interface IAirVehicle :  IVehicle
    {
        int Elevation
        {
            get;
            set;
        }
    }

    public interface IAirplane : IAirVehicle
    {
        int Capacity
        {
            get;
            set;
        }
    }
                 
    public class GenericVehicle : IVehicle
    {
        #region IVehicle Members
        int wheels = 0;
        public int Wheels
        {
            get
            {
                return wheels;
            }
            set
            {
                wheels = value;
            }
        }

        #endregion

    }

    public class Airplane : IAirplane
    {
        private int capacity, elevation, wheels;

        public Airplane()
        {
            capacity = 200;
            elevation = 0;
            wheels = 4;
        }
        #region IAirplane Members

        public int Capacity
        {
            get
            {
                return this.capacity;
            }
            set
            {
                this.capacity = value;
            }
        }

        #endregion

        #region IAirVehicle Members

        public int Elevation
        {
            get
            {
                return this.elevation;
            }
            set
            {
                this.elevation = value;
            }
        }

        #endregion

        #region IVehicle Members

        public int Wheels
        {
            get
            {
                return this.wheels;
            }
            set
            {
                this.wheels = value;
            }
        }

        #endregion
    }

    public class NonInterfaceClass
    {
        public void Test()
        {
            Console.WriteLine( "NonInterfaceClass.Test succeeded" );
        }
    }
}
    