using System;
using System.Drawing;
using System.Collections;
using System.Windows.Forms;
using System.Data;
using System.Data.SqlServerCe;

namespace _16_SqlServerCEClient
{
    public class Form1 : System.Windows.Forms.Form
    {
        #region Windows Form Control Variables
        private System.Windows.Forms.DataGrid dataGrid1;
        private System.Windows.Forms.MenuItem menuItem1;
        private System.Windows.Forms.MenuItem mnuExit;
        private System.Windows.Forms.MainMenu mainMenu1;
        private System.Windows.Forms.MenuItem menuItem2;
        private System.Windows.Forms.MenuItem mnuAdd;
        private System.Windows.Forms.TextBox tbNewValue;
        private System.Windows.Forms.Button btnChange;
        private System.Windows.Forms.MenuItem mnuDelete;
        #endregion

        SqlCeConnection sqlConnection;
        SqlCeDataAdapter sqlDataAdapter;
        SqlCeCommandBuilder cmdBuilder;
        DataSet catalogDataSet;
        
        public Form1()
        {
            InitializeComponent();

            sqlConnection = new SqlCeConnection( @"Data Source=/My Documents/MusicCatalog.sdf;" );
            
            string selectCmd   = "SELECT * From Catalog";
            
            // create the adapter
            sqlDataAdapter = new SqlCeDataAdapter();    
            
            // assign select command
            sqlDataAdapter.SelectCommand    = new SqlCeCommand(selectCmd, sqlConnection);

            cmdBuilder = new SqlCeCommandBuilder( sqlDataAdapter );
            
            // create dataset
            catalogDataSet = new DataSet("Catalog");
            
            // fill dataset
            sqlDataAdapter.Fill(catalogDataSet, "Catalog" ); 

            // databind datagrid
            dataGrid1.DataSource = catalogDataSet.Tables["Catalog"];
            sqlConnection.Close();
            
        }
        /// <summary>
        /// Clean up any resources being used.
        /// </summary>
        protected override void Dispose( bool disposing )
        {
            base.Dispose( disposing );
        }
        #region Windows Form Designer generated code
        /// <summary>
        /// Required method for Designer support - do not modify
        /// the contents of this method with the code editor.
        /// </summary>
        private void InitializeComponent()
        {
            this.mainMenu1 = new System.Windows.Forms.MainMenu();
            this.menuItem1 = new System.Windows.Forms.MenuItem();
            this.mnuExit = new System.Windows.Forms.MenuItem();
            this.menuItem2 = new System.Windows.Forms.MenuItem();
            this.mnuAdd = new System.Windows.Forms.MenuItem();
            this.mnuDelete = new System.Windows.Forms.MenuItem();
            this.dataGrid1 = new System.Windows.Forms.DataGrid();
            this.tbNewValue = new System.Windows.Forms.TextBox();
            this.btnChange = new System.Windows.Forms.Button();
            // 
            // mainMenu1
            // 
            this.mainMenu1.MenuItems.Add(this.menuItem1);
            this.mainMenu1.MenuItems.Add(this.menuItem2);
            // 
            // menuItem1
            // 
            this.menuItem1.MenuItems.Add(this.mnuExit);
            this.menuItem1.Text = "File";
            // 
            // mnuExit
            // 
            this.mnuExit.Text = "E&xit";
            this.mnuExit.Click += new System.EventHandler(this.mnuExit_Click);
            // 
            // menuItem2
            // 
            this.menuItem2.MenuItems.Add(this.mnuAdd);
            this.menuItem2.MenuItems.Add(this.mnuDelete);
            this.menuItem2.Text = "Record";
            // 
            // mnuAdd
            // 
            this.mnuAdd.Text = "Add";
            this.mnuAdd.Click += new System.EventHandler(this.mnuAdd_Click);
            // 
            // mnuDelete
            // 
            this.mnuDelete.Text = "Delete";
            this.mnuDelete.Click += new System.EventHandler(this.mnuDelete_Click);
            // 
            // dataGrid1
            // 
            this.dataGrid1.Location = new System.Drawing.Point(8, 8);
            this.dataGrid1.Size = new System.Drawing.Size(224, 232);
            this.dataGrid1.Text = "dataGrid1";
            // 
            // tbNewValue
            // 
            this.tbNewValue.Location = new System.Drawing.Point(8, 248);
            this.tbNewValue.Size = new System.Drawing.Size(144, 22);
            this.tbNewValue.Text = "textBox1";
            // 
            // btnChange
            // 
            this.btnChange.Location = new System.Drawing.Point(160, 248);
            this.btnChange.Size = new System.Drawing.Size(72, 22);
            this.btnChange.Text = "Change";
            this.btnChange.Click += new System.EventHandler(this.btnChange_Click);
            // 
            // Form1
            // 
            this.Controls.Add(this.btnChange);
            this.Controls.Add(this.tbNewValue);
            this.Controls.Add(this.dataGrid1);
            this.Menu = this.mainMenu1;
            this.Text = "Form1";

        }
        #endregion

        /// <summary>
        /// The main entry point for the application.
        /// </summary>

        static void Main() 
        {
            Application.Run(new Form1());
        }

        private void mnuExit_Click(object sender, System.EventArgs e)
        {
            this.Close();
        }

        private void mnuAdd_Click(object sender, System.EventArgs e)
        {
            DataRow newRow = catalogDataSet.Tables["Catalog"].NewRow();
            newRow["Title"] = "Song Title";
            newRow["Artist"] = "Artist";

            catalogDataSet.Tables["Catalog"].Rows.Add( newRow );
            sqlDataAdapter.Update( catalogDataSet, "Catalog" );
        }

        private void btnChange_Click(object sender, System.EventArgs e)
        {
            DataGridCell currentCell;
            string currentCellData;

            // Get the text to put into the current cell.
            currentCellData = tbNewValue.Text;

            // Get the current cell.
            currentCell = dataGrid1.CurrentCell;

            // Set the current cell's data.
            dataGrid1[currentCell.RowNumber,currentCell.ColumnNumber] = currentCellData;

            // update the data source
            DataRow updateRow = catalogDataSet.Tables["Catalog"].Rows[dataGrid1.CurrentRowIndex];
            updateRow["Title"] = dataGrid1[dataGrid1.CurrentRowIndex,1];
            updateRow["Artist"] = dataGrid1[dataGrid1.CurrentRowIndex,2];
            sqlDataAdapter.Update( catalogDataSet, "Catalog" );
        }

        private void mnuDelete_Click(object sender, System.EventArgs e)
        {
            DataRow updateRow = catalogDataSet.Tables["Catalog"].Rows[dataGrid1.CurrentRowIndex];
            updateRow.Delete();
            sqlDataAdapter.Update( catalogDataSet, "Catalog" );
        }
    }
}
