using System;
using System.Drawing;
using System.Collections;
using System.Windows.Forms;
using System.Data;
using Microsoft.WindowsCE.Forms;
using System.Runtime.InteropServices;
using System.Text;

namespace _6_MessageWindow
{
    /// <summary>
    /// Summary description for Form1.
    /// </summary>
    public class DeviceWindowsForm : System.Windows.Forms.Form
    {
        private System.Windows.Forms.MainMenu mainMenu1;
        private System.Windows.Forms.Button btnClose;
        private MessageHandler handler;
        private Hashtable hWndTable;
        private GameControl.GameBoard GameBoard1;
        private System.Windows.Forms.ListBox listBox1;
        
        public const int WM_CLOSE = 0x0010;

        public DeviceWindowsForm()
        {
            InitializeComponent();

            hWndTable = new Hashtable();
            handler = new MessageHandler( this );

            // fill the listbox
            handler.EnumWindows();
        }

        protected override void Dispose( bool disposing )
        {
            base.Dispose( disposing );
        }
        #region Windows Form Designer generated code
        /// <summary>
        /// Required method for Designer support - do not modify
        /// the contents of this method with the code editor.
        /// </summary>
        private void InitializeComponent()
        {
            this.mainMenu1 = new System.Windows.Forms.MainMenu();
            this.btnClose = new System.Windows.Forms.Button();
            this.GameBoard1 = new GameControl.GameBoard();
            this.listBox1 = new System.Windows.Forms.ListBox();
            // 
            // btnClose
            // 
            this.btnClose.Location = new System.Drawing.Point(80, 232);
            this.btnClose.Text = "Close";
            this.btnClose.Click += new System.EventHandler(this.btnClose_Click);
            // 
            // GameBoard1
            // 
            this.GameBoard1.GridSize = 74;
            this.GameBoard1.Location = new System.Drawing.Point(8, 0);
            this.GameBoard1.ShowGrid = true;
            this.GameBoard1.Size = new System.Drawing.Size(240, 224);
            this.GameBoard1.Text = "gameBoard1";
            // 
            // listBox1
            // 
            this.listBox1.Size = new System.Drawing.Size(240, 226);
            // 
            // DeviceWindowsForm
            // 
            this.Controls.Add(this.GameBoard1);
            this.Controls.Add(this.btnClose);
            this.Controls.Add(this.listBox1);
            this.Menu = this.mainMenu1;
            this.Text = "Form1";

        }
        #endregion

        static void Main() 
        {
            Application.Run(new DeviceWindowsForm());
        }

        public void AddWindow( IntPtr hWnd, string WindowTitle )
        {
            // save window handle
            hWndTable[WindowTitle] = hWnd;   

            // add to listbox
            listBox1.Items.Add( WindowTitle );
        }

        private void btnClose_Click(object sender, System.EventArgs e)
        {
            Message msg;

            // get selected hwnd
            IntPtr hwnd = (IntPtr) hWndTable[listBox1.SelectedItem.ToString()];

            // create the message to send
            msg = Message.Create( hwnd, WM_CLOSE, (IntPtr) 0, (IntPtr) 0 );

            // close the window
            MessageWindow.SendMessage( ref msg );

            // refresh listbox
            listBox1.Items.Clear();
            handler.EnumWindows();
        }
    }

    public class MessageHandler : MessageWindow
    {
        public const int WM_USER_ADDWINDOW = 0x0401;
        
        [DllImport(@"\Windows\MessageWindowNative.dll")]
        public extern static void EnumerateDeviceWindows(IntPtr hWnd);

        [DllImport("coredll.dll")]
        static extern int GetWindowText(int hWnd, StringBuilder text, int count);

        // the main application form
        DeviceWindowsForm mainForm;

        public MessageHandler(DeviceWindowsForm mainForm)
        {
            // save the form to post back to
            this.mainForm = mainForm;
        }

        public void EnumWindows()
        {
            // call the native dll function
            EnumerateDeviceWindows( this.Hwnd );
        }

        // Override the default WndProc behavior to monitor messages.
        protected override void WndProc(ref Message msg)
        {
            switch(msg.Msg)
            {
                case WM_USER_ADDWINDOW:
                {
                    // get the window title using GetWindowText
                    StringBuilder windowText = new StringBuilder(1024);
                    GetWindowText( msg.LParam.ToInt32(), windowText, 1024 );
                    if( windowText.ToString() == "" )
                        break;

                    // if wParam is 1 then window is a child of someone
                    if( msg.WParam.ToInt32() == 1 )
                        windowText.Insert( 0, "    " );

                    // add it to the listbox of the main form
                    mainForm.AddWindow( msg.LParam, windowText.ToString() );
                    break;
                }
                default:
                {
                    break;
                }
            }

            // Call the base class WndProc for default message handling.
            base.WndProc(ref msg);
        }
    }

}
