using System;
using System.Drawing;
using System.Collections;
using System.Windows.Forms;
using System.Data;
using System.IO;
using Microsoft.WindowsCE.Forms;

namespace PocketNotepad
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
    ///  

	public class Form1 : System.Windows.Forms.Form
	{
        private System.Windows.Forms.TextBox textBox1;
        private Microsoft.WindowsCE.Forms.InputPanel inputPanel1;
        private System.Windows.Forms.MenuItem menuItem1;
        private System.Windows.Forms.MenuItem mnuNew;
        private System.Windows.Forms.MenuItem mnuOpen;
        private System.Windows.Forms.MenuItem mnuSave;
        private System.Windows.Forms.MenuItem mnuSaveAs;
        private System.Windows.Forms.MenuItem menuItem6;
        private System.Windows.Forms.MenuItem mnuExit;
        private System.Windows.Forms.MenuItem menuItem8;
        private System.Windows.Forms.MenuItem mnuCut;
        private System.Windows.Forms.MenuItem mnuCopy;
        private System.Windows.Forms.MenuItem mnuPaste;
		private System.Windows.Forms.MainMenu mainMenu1;
        private bool hasChanges = false;
        private System.Windows.Forms.SaveFileDialog saveFileDialog1;
        private System.Windows.Forms.OpenFileDialog openFileDialog1;
        private string fileName = null;
        private string clipboard = "";

		public Form1()
		{
			InitializeComponent();
		}
		protected override void Dispose( bool disposing )
		{
			base.Dispose( disposing );
		}
		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
            this.mainMenu1 = new System.Windows.Forms.MainMenu();
            this.menuItem1 = new System.Windows.Forms.MenuItem();
            this.mnuNew = new System.Windows.Forms.MenuItem();
            this.mnuOpen = new System.Windows.Forms.MenuItem();
            this.mnuSave = new System.Windows.Forms.MenuItem();
            this.mnuSaveAs = new System.Windows.Forms.MenuItem();
            this.menuItem6 = new System.Windows.Forms.MenuItem();
            this.mnuExit = new System.Windows.Forms.MenuItem();
            this.menuItem8 = new System.Windows.Forms.MenuItem();
            this.mnuCut = new System.Windows.Forms.MenuItem();
            this.mnuCopy = new System.Windows.Forms.MenuItem();
            this.mnuPaste = new System.Windows.Forms.MenuItem();
            this.textBox1 = new System.Windows.Forms.TextBox();
            this.inputPanel1 = new Microsoft.WindowsCE.Forms.InputPanel();
            this.saveFileDialog1 = new System.Windows.Forms.SaveFileDialog();
            this.openFileDialog1 = new System.Windows.Forms.OpenFileDialog();
            // 
            // mainMenu1
            // 
            this.mainMenu1.MenuItems.Add(this.menuItem1);
            this.mainMenu1.MenuItems.Add(this.menuItem8);
            // 
            // menuItem1
            // 
            this.menuItem1.MenuItems.Add(this.mnuNew);
            this.menuItem1.MenuItems.Add(this.mnuOpen);
            this.menuItem1.MenuItems.Add(this.mnuSave);
            this.menuItem1.MenuItems.Add(this.mnuSaveAs);
            this.menuItem1.MenuItems.Add(this.menuItem6);
            this.menuItem1.MenuItems.Add(this.mnuExit);
            this.menuItem1.Text = "File";
            // 
            // mnuNew
            // 
            this.mnuNew.Text = "New";
            this.mnuNew.Click += new System.EventHandler(this.mnuNew_Click);
            // 
            // mnuOpen
            // 
            this.mnuOpen.Text = "Open";
            this.mnuOpen.Click += new System.EventHandler(this.mnuOpen_Click);
            // 
            // mnuSave
            // 
            this.mnuSave.Text = "Save";
            this.mnuSave.Click += new System.EventHandler(this.mnuSave_Click);
            // 
            // mnuSaveAs
            // 
            this.mnuSaveAs.Text = "Save As";
            this.mnuSaveAs.Click += new System.EventHandler(this.mnuSaveAs_Click);
            // 
            // menuItem6
            // 
            this.menuItem6.Text = "-";
            // 
            // mnuExit
            // 
            this.mnuExit.Text = "Exit";
            this.mnuExit.Click += new System.EventHandler(this.mnuExit_Click);
            // 
            // menuItem8
            // 
            this.menuItem8.MenuItems.Add(this.mnuCut);
            this.menuItem8.MenuItems.Add(this.mnuCopy);
            this.menuItem8.MenuItems.Add(this.mnuPaste);
            this.menuItem8.Text = "Edit";
            // 
            // mnuCut
            // 
            this.mnuCut.Text = "Cut";
            this.mnuCut.Click += new System.EventHandler(this.mnuCut_Click);
            // 
            // mnuCopy
            // 
            this.mnuCopy.Text = "Copy";
            this.mnuCopy.Click += new System.EventHandler(this.mnuCopy_Click);
            // 
            // mnuPaste
            // 
            this.mnuPaste.Text = "Paste";
            this.mnuPaste.Click += new System.EventHandler(this.mnuPaste_Click);
            // 
            // textBox1
            // 
            this.textBox1.Multiline = true;
            this.textBox1.ScrollBars = System.Windows.Forms.ScrollBars.Vertical;
            this.textBox1.Size = new System.Drawing.Size(240, 272);
            this.textBox1.Text = "";
            this.textBox1.LostFocus += new System.EventHandler(this.textBox1_LostFocus);
            this.textBox1.GotFocus += new System.EventHandler(this.textBox1_GotFocus);
            this.textBox1.TextChanged += new System.EventHandler(this.textBox1_TextChanged);
            // 
            // saveFileDialog1
            // 
            this.saveFileDialog1.FileName = "doc1";
            this.saveFileDialog1.Filter = "Text Files(*.txt)|*.txt|All Files(*.*)|*.*";
            // 
            // openFileDialog1
            // 
            this.openFileDialog1.Filter = "Text Files(*.txt)|*.txt|All Files(*.*)|*.*";
            // 
            // Form1
            // 
            this.Controls.Add(this.textBox1);
            this.Menu = this.mainMenu1;
            this.MinimizeBox = false;
            this.Text = "Pocket Notepad";

        }
		#endregion

		static void Main() 
		{
			Application.Run(new Form1());
		}

        private void textBox1_GotFocus(object sender, System.EventArgs e)
        {
            inputPanel1.Enabled = true;
        }

        private void textBox1_LostFocus(object sender, System.EventArgs e)
        {
            inputPanel1.Enabled = false;
        }

        private void mnuExit_Click(object sender, System.EventArgs e)
        {
            if( hasChanges == true )
            {
                if( MessageBox.Show( "The text has changed. Would you like to save?", "Pocket Notepad", MessageBoxButtons.YesNo,
                    MessageBoxIcon.Question, MessageBoxDefaultButton.Button1 ) == DialogResult.Yes )
                {

                    if( Save() != DialogResult.OK )
                        return;
                }
            }
            this.Close();
        }

        private DialogResult Save()
        {
            string saveName = fileName;
            DialogResult action = DialogResult.OK;

            if( hasChanges == false )
                return action;

            if( fileName == null )
            {
                action = saveFileDialog1.ShowDialog();
                if( action == DialogResult.OK )
                {
                    saveName = saveFileDialog1.FileName;
                    fileName = saveName;
                }
                else
                {
                    return action;
                }
            }

            TextWriter tw = File.CreateText( saveName );
            tw.Write( textBox1.Text );
            tw.Close();
            hasChanges = false;

            return action;
        }

        private void textBox1_TextChanged(object sender, System.EventArgs e)
        {
            if( hasChanges == false )
                hasChanges = true;
        }

        private void mnuSave_Click(object sender, System.EventArgs e)
        {
            Save();
        }

        private void mnuSaveAs_Click(object sender, System.EventArgs e)
        {
            Save();
        }

        private void mnuNew_Click(object sender, System.EventArgs e)
        {
            if( hasChanges == true )
            {
                if( MessageBox.Show( "The text has changed. Would you like to save?", "Pocket Notepad", MessageBoxButtons.YesNo,
                    MessageBoxIcon.Question, MessageBoxDefaultButton.Button1 ) == DialogResult.No )
                    return;
            
                if( Save() != DialogResult.OK )
                    return;
            }
            textBox1.Text = "";
            hasChanges = false;
            fileName = null;
        }

        private void mnuOpen_Click(object sender, System.EventArgs e)
        {
            if( hasChanges == true )
            {
              if( MessageBox.Show("The text has changed. Would you like to save?", "Pocket Notepad", MessageBoxButtons.YesNo,
                    MessageBoxIcon.Question, MessageBoxDefaultButton.Button1 ) == DialogResult.No )
                    return;
            
                if( Save() != DialogResult.OK )
                    return;
            }
            if( openFileDialog1.ShowDialog() == DialogResult.OK )
            {
                TextReader tr = File.OpenText( openFileDialog1.FileName );
                textBox1.Text = tr.ReadToEnd();
                tr.Close();
                hasChanges = false;
                fileName = openFileDialog1.FileName;
            }
        }

        private void mnuCut_Click(object sender, System.EventArgs e)
        {
            clipboard = textBox1.SelectedText;
            textBox1.Text = textBox1.Text.Replace( textBox1.SelectedText, "" );
        }

        private void mnuCopy_Click(object sender, System.EventArgs e)
        {
            clipboard = textBox1.SelectedText;
        }

        private void mnuPaste_Click(object sender, System.EventArgs e)
        {
            textBox1.SelectedText = clipboard;
            textBox1.ScrollToCaret();
        }
	}
}
